package org.mmc.model.domain;

import org.mmc.utils.StringUtils;

import java.io.Serializable;
import java.util.Date;

/**
 * Created on: 2007-10-3
 *
 * @author Stoyo Venkov
 */
public class Patient implements Serializable {
    private Long id;
    private String firstName;
    private String secondName;
    private String familyName;
    private String initials;
    private String address;
    private String email;
    private String phoneNumber;
    private Integer birthDay;
    private Integer birthMonth;
    private Integer birthYear;
    private Date registrationDate;
    private Sex sex;
    private EthnicGroup ethnicGroup;
    private User user;
    private String uniqueNumber;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getFirstName() {
        return firstName;
    }

    public void setFirstName(String firstName) {
        this.firstName = firstName;
    }

    public String getSecondName() {
        return secondName;
    }

    public void setSecondName(String secondName) {
        this.secondName = secondName;
    }

    public String getFamilyName() {
        return familyName;
    }

    public void setFamilyName(String familyName) {
        this.familyName = familyName;
    }

    public String getInitials() {
        return initials;
    }

    public void setInitials(String initials) {
        this.initials = initials;
    }

    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getPhoneNumber() {
        return phoneNumber;
    }

    public void setPhoneNumber(String phoneNumber) {
        this.phoneNumber = phoneNumber;
    }

    public Integer getBirthDay() {
        return birthDay;
    }

    public void setBirthDay(Integer birthDay) {
        this.birthDay = birthDay;
    }

    public Integer getBirthMonth() {
        return birthMonth;
    }

    public void setBirthMonth(Integer birthMonth) {
        this.birthMonth = birthMonth;
    }

    public Integer getBirthYear() {
        return birthYear;
    }

    public void setBirthYear(Integer birthYear) {
        this.birthYear = birthYear;
    }

    public Date getRegistrationDate() {
        return registrationDate;
    }

    public void setRegistrationDate(Date registrationDate) {
        this.registrationDate = registrationDate;
    }

    public Sex getSex() {
        return sex;
    }

    public void setSex(Sex sex) {
        this.sex = sex;
    }

    public EthnicGroup getEthnicGroup() {
        return ethnicGroup;
    }

    public void setEthnicGroup(EthnicGroup ethnicGroup) {
        this.ethnicGroup = ethnicGroup;
    }

    public User getUser() {
        return user;
    }

    public void setUser(User user) {
        this.user = user;
    }

    public String getUniqueNumber() {
        return uniqueNumber;
    }

    public void setUniqueNumber(String uniqueNumber) {
        this.uniqueNumber = uniqueNumber;
    }

    public String getNameInfo() {
        StringBuffer result = new StringBuffer();
        if(!StringUtils.isEmpty(firstName)) {
            result.append(firstName).append(" ");
        }
        if(!StringUtils.isEmpty(familyName)) {
            result.append(familyName).append(" ");
        }
        if(!StringUtils.isEmpty(initials)) {
            result.append(initials);
        }
        return result.toString();
    }

    public String toString() {
        return getNameInfo();
    }
}
