package org.mmc.model.domain;

import org.mmc.utils.DateTimeUtils;

import java.io.Serializable;
import java.util.Date;
import java.util.List;
import java.util.GregorianCalendar;

/**
 * Created on: 2007-10-6
 *
 * @author Stoyo Venkov
 */
public class Probe implements Serializable {
    private Long id;
    private User creator;
    private Integer termInDays;
    private AnalysisRequest request;
    private Patient patient;
    private Date registrationDate;
    private ProbeType type;
    private Date finishDate;
    private Boolean finished;
    private Boolean canceled;
    private Boolean resultSent;
    private String cancelationReason;
    private List probeProjects;
    private List probeCriteria;
    private List steps;
    private Integer daysToCompletion;
    private Boolean expired;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public User getCreator() {
        return creator;
    }

    public void setCreator(User creator) {
        this.creator = creator;
    }

    public Integer getTermInDays() {
        return termInDays;
    }

    public void setTermInDays(Integer termInDays) {
        this.termInDays = termInDays;
    }

    public AnalysisRequest getRequest() {
        return request;
    }

    public void setRequest(AnalysisRequest request) {
        this.request = request;
    }

    public Patient getPatient() {
        return patient;
    }

    public void setPatient(Patient patient) {
        this.patient = patient;
    }

    public Date getRegistrationDate() {
        return registrationDate;
    }

    public void setRegistrationDate(Date registrationDate) {
        this.registrationDate = registrationDate;
    }

    public ProbeType getType() {
        return type;
    }

    public void setType(ProbeType type) {
        this.type = type;
    }

    public Date getFinishDate() {
        return finishDate;
    }

    public void setFinishDate(Date finishDate) {
        this.finishDate = finishDate;
    }

    public Boolean getFinished() {
        return finished;
    }

    public void setFinished(Boolean finished) {
        this.finished = finished;
    }

    public Boolean getCanceled() {
        return canceled;
    }

    public void setCanceled(Boolean canceled) {
        this.canceled = canceled;
    }

    public Boolean getResultSent() {
        return resultSent;
    }

    public void setResultSent(Boolean resultSent) {
        this.resultSent = resultSent;
    }

    public String getCancelationReason() {
        return cancelationReason;
    }

    public void setCancelationReason(String cancelationReason) {
        this.cancelationReason = cancelationReason;
    }

    public List getProbeProjects() {
        return probeProjects;
    }

    public void setProbeProjects(List probeProjects) {
        this.probeProjects = probeProjects;
    }

    public List getProbeCriteria() {
        return probeCriteria;
    }

    public void setProbeCriteria(List probeCriteria) {
        this.probeCriteria = probeCriteria;
    }

    public List getSteps() {
        return steps;
    }

    public void setSteps(List steps) {
        this.steps = steps;
    }

    public Integer getDaysToCompletion() {
        return daysToCompletion;
    }

    public void setDaysToCompletion(Integer daysToCompletion) {
        this.daysToCompletion = daysToCompletion;
    }

    public Boolean getExpired() {
        return expired;
    }

    public void setExpired(Boolean expired) {
        this.expired = expired;
    }

    public Integer getDaysPastExpiration() {
        if(expired != null && expired.booleanValue()) {
            return new Integer(-daysToCompletion.intValue());
        }
        return new Integer(0);
    }

    public Date getFinalDate() {
        GregorianCalendar cal = new GregorianCalendar();
        cal.setTime(registrationDate);
        cal.add(GregorianCalendar.DAY_OF_YEAR, termInDays.intValue());
        return cal.getTime();
    }

    public String getFinalDateStr() {
        return DateTimeUtils.formatDate(getFinalDate());
    }

    public String getRegDateStr() {
        return DateTimeUtils.formatDate(registrationDate);
    }
}
