package org.mmc.model.filters;

import java.io.Serializable;

/**
 * Created on: 2007-9-15
 *
 * @author Stoyo Venkov
 */
public class BasePageFilter implements Serializable {
    protected int pageNumber;
    protected int pageSize;
    protected int resultSize;

    public BasePageFilter(int pageSize) {
        this.pageSize = pageSize;
        this.pageNumber = 0;
        this.resultSize = 0;
    }

     public int getPageNumber() {
        return pageNumber;
    }

    public void setPageNumber(int pageNumber) {
        this.pageNumber = pageNumber;
    }

    public int getPageSize() {
        return pageSize;
    }

    public void setPageSize(int pageSize) {
        this.pageSize = pageSize;
    }

    public int getResultSize() {
        return resultSize;
    }

    public void setResultSize(int resultSize) {
        this.resultSize = resultSize;
    }

    public boolean isNextPage() {
       return resultSize > pageSize;
   }

   public boolean isPreviousPage() {
       return pageNumber > 0;
   }

   public int getCriteriaFirstResult() {
       return pageSize * pageNumber;
   }

   public int getCriteriaMaxResult() {
       return pageSize + 1;
   }
}
