package org.mmc.model.persistence.dao;

import org.springframework.orm.hibernate3.support.HibernateDaoSupport;
import org.hibernate.criterion.DetachedCriteria;
import org.hibernate.criterion.Expression;
import org.mmc.model.domain.ConfParam;

import java.util.List;

/**
 * Created on: 2007-10-20
 *
 * @author Stoyo Venkov
 */
public class ConfParamsDaoHbrImpl extends HibernateDaoSupport implements ConfParamsDao {
    public String getParamValue(String code) {
        ConfParam param = getParamByCode(code);
        if(param != null) {
            return param.getValue();
        }
        return null;  //To change body of implemented methods use File | Settings | File Templates.
    }

    public void updateParam(String code, String value) {
        ConfParam param = getParamByCode(code);
        if(param != null) {
            param.setValue(value);
            getHibernateTemplate().update(param);
        }
    }

    public ConfParam getParamByCode(String code) {
        DetachedCriteria crit = DetachedCriteria.forClass(ConfParam.class);
        crit.add(Expression.eq("code", code));
        List found = getHibernateTemplate().findByCriteria(crit);
        if(found != null && found.size() > 0) {
            return (ConfParam) found.get(0);
        }

        return null;
    }
}
