package org.mmc.model.persistence.dao;

import org.mmc.model.domain.*;
import org.springframework.orm.hibernate3.support.HibernateDaoSupport;
import org.hibernate.criterion.DetachedCriteria;
import org.hibernate.criterion.Expression;

import java.io.Serializable;
import java.util.List;

/**
 * Created on: 2007-10-7
 *
 * @author Stoyo Venkov
 */
public class ContainerAndGroupsDaoHbrImpl extends HibernateDaoSupport implements ContainerAndGroupsDao {
    public ContainerObject saveContainer(ContainerObject object) {
        Serializable iId = getHibernateTemplate().save(object);
        object.setId((Long) iId);
        return object;
    }

    public ContainerObject updateContainer(ContainerObject object) {
        getHibernateTemplate().update(object);
        return object;
    }

    public BatchGroup saveBatchGroup(BatchGroup object) {
        Serializable iId = getHibernateTemplate().save(object);
        object.setId((Long) iId);
        return object;
    }

    public BatchGroup updateBatchGroup(BatchGroup object) {
        getHibernateTemplate().update(object);
        return object;
    }

    public Tube getTubeById(Long id) {
        DetachedCriteria crit = DetachedCriteria.forClass(Tube.class);
        crit.add(Expression.eq("id", id));

        List result = getHibernateTemplate().findByCriteria(crit);

        if(result != null) {
            if(result.size() > 0) {
                return (Tube) result.get(0);
            }
        }

        return null;
    }

    public Rack getRackById(Long id) {
        DetachedCriteria crit = DetachedCriteria.forClass(Rack.class);
        crit.add(Expression.eq("id", id));

        List result = getHibernateTemplate().findByCriteria(crit);

        if(result != null) {
            if(result.size() > 0) {
                return (Rack) result.get(0);
            }
        }

        return null;
    }

    public Plate getPlateById(Long id) {
        DetachedCriteria crit = DetachedCriteria.forClass(Plate.class);
        crit.add(Expression.eq("id", id));

        List result = getHibernateTemplate().findByCriteria(crit);

        if(result != null) {
            if(result.size() > 0) {
                return (Plate) result.get(0);
            }
        }

        return null;
    }

    public BatchGroup getBatchGroupById(Long id) {
        DetachedCriteria crit = DetachedCriteria.forClass(BatchGroup.class);
        crit.add(Expression.eq("id", id));

        List result = getHibernateTemplate().findByCriteria(crit);

        if(result != null) {
            if(result.size() > 0) {
                return (BatchGroup) result.get(0);
            }
        }

        return null;
    }
}
