package org.mmc.model.persistence.dao;

import org.mmc.model.domain.Probe;
import org.mmc.model.domain.Location;
import org.mmc.model.domain.Step;
import org.mmc.model.domain.LocationChange;
import org.mmc.model.filters.ProbesFilter;

import java.util.List;

/**
 * Created on: 2007-10-6
 *
 * @author Stoyo Venkov
 */
public interface ProbesDao extends BaseDao {
    public Probe getProbeById(Long id);
    public List getProbesByFilter(ProbesFilter filter);
    public Probe saveProbe(Probe probe);
    public Probe updateProbe(Probe probe);
    public Location getLocationById(Long id);
    public Location getFirstLocation(Long stepId);
    public List getChildrenLocations(Long locationId, Long projectId);
    public Step getStepById(Long id);
    public Step saveStep(Step step);
    public Step updateStep(Step step);
    public Location saveLocation(Location location);
    public void registerMovement(LocationChange lc);
    public List getProbeSteps(Probe probe);
    public List getAllProbesByFilter(ProbesFilter filter);
}
