package org.mmc.model.service;

import org.mmc.model.domain.AnalysisRequest;
import org.mmc.model.filters.RequestsFilter;

import java.util.List;

/**
 * Created on: 2007-10-7
 *
 * @author Stoyo Venkov
 */
public interface AnalysisRequestsService {
    /**
     * Finds analysis request by its id.
     * @param id The id to be searched for.
     * @return The request's object if found, null - otherwise.
     */
    public AnalysisRequest getRequestById(Long id);

    /**
     * Finds analysis requests by filter.
     *
     * @param filter The requests' filter object.
     * @return List of all filtered requests.
     */
    public List getRequestsByFilter(RequestsFilter filter);
}
