package org.mmc.model.service;

import org.mmc.model.persistence.dao.CriteriaDao;
import org.mmc.model.filters.CriteriaFilter;
import org.mmc.model.domain.Criterion;

import java.util.List;

/**
 * Created on: 2007-9-20
 *
 * @author Stoyo Venkov
 */
public class CriteriaDaoService implements CriteriaService {
    private CriteriaDao dao;

    public CriteriaDao getDao() {
        return dao;
    }

    public void setDao(CriteriaDao dao) {
        this.dao = dao;
    }

    public List getAllCriteria() {
        return dao.getAllCriteria();
    }

    public List getCriteriaByFilter(CriteriaFilter filter) {
        return dao.getCriteriaByFilter(filter);
    }

    public Criterion getCriterionById(long id) {
        return dao.getCriterionById(id);
    }

    public Criterion updateCriterion(Criterion criterion) {
        return dao.updateCriterion(criterion);
    }

    public Criterion saveCriterion(Criterion criterion) {
        return dao.saveCriterion(criterion);
    }

    public Criterion saveOrUpdateCriterion(Criterion criterion) {
        if(criterion.getId() != null) {
            return updateCriterion(criterion);
        } else {
            return saveCriterion(criterion);
        }
    }
}
