package org.mmc.model.service;

import org.mmc.model.persistence.dao.DiseasesDao;
import org.mmc.model.domain.Disease;
import org.mmc.model.filters.DiseasesFilter;

import java.util.List;

/**
 * Created on: 2007-9-8
 *
 * @author Stoyo Venkov
 */
public class DiseasesDaoService implements DiseasesService {
    private DiseasesDao dao;

    public DiseasesDao getDao() {
        return dao;
    }

    public void setDao(DiseasesDao dao) {
        this.dao = dao;
    }

    public List getAllDiseases() {
        return dao.getAllDiseases();
    }

    public List getAllActive() {
        return dao.getAllActive();
    }

    public List getDiseasesByFilter(DiseasesFilter disease) {
        return dao.getDiseasesByFilter(disease);
    }

    public Disease getDiseaseById(long diseaseId) {
        return dao.getDiseaseById(diseaseId);
    }

    public Disease updateDisease(Disease disease) {
        return dao.updateDisease(disease);
    }

    public Disease saveDisease(Disease disease) {
        return dao.saveDisease(disease);
    }

    public Disease saveOrUpdateDisease(Disease disease) {
        if(disease.getId() != null) {
            return updateDisease(disease);
        } else {
            return saveDisease(disease);
        }
    }
}
