package org.mmc.model.service;

import org.mmc.model.filters.EthnicGroupFilter;
import org.mmc.model.domain.EthnicGroup;
import org.mmc.model.persistence.dao.EthnicGroupsDao;

import java.util.List;

/**
 * Created on: 2007-9-17
 *
 * @author Stoyo Venkov
 */
public class EthnicGroupsDaoService implements EthnicGroupsService {
    private EthnicGroupsDao dao;

    public EthnicGroupsDao getDao() {
        return dao;
    }

    public void setDao(EthnicGroupsDao dao) {
        this.dao = dao;
    }

    public List getAllEthnicGroups() {
        return dao.getAllEthnicGroups();
    }

    public List getEthnicGroupsByFilter(EthnicGroupFilter filter) {
        return dao.getEthnicGroupsByFilter(filter);
    }

    public EthnicGroup getEthnicGroupById(long id) {
        return dao.getEthnicGroupById(id);
    }

    public EthnicGroup updateEthnicGroup(EthnicGroup group) {
        return dao.updateEthnicGroup(group);
    }

    public EthnicGroup saveEthnicGroup(EthnicGroup group) {
        return dao.saveEthnicGroup(group);
    }

    public EthnicGroup saveOrUpdateEthnicGroup(EthnicGroup group) {
        if(group.getId() != null) {
            return updateEthnicGroup(group);
        } else {
            return saveEthnicGroup(group);
        }
    }
}
