package org.mmc.model.service;

import org.mmc.model.filters.PositionFilter;
import org.mmc.model.domain.MMCPosition;
import org.mmc.model.persistence.dao.MMCPositionsDao;

import java.util.List;

/**
 * Created on: 2007-9-16
 *
 * @author Stoyo Venkov
 */
public class MMCPositionsDaoService implements MMCPositionsService{
    private MMCPositionsDao dao;

    public MMCPositionsDao getDao() {
        return dao;
    }

    public void setDao(MMCPositionsDao dao) {
        this.dao = dao;
    }

    public List getAllPositions() {
        return dao.getAllMMCPositions();
    }

    public List getAllActive() {
        return dao.getAllActive();
    }

    public List getPositionsByFilter(PositionFilter filter) {
        return dao.getPositionsByFilter(filter);
    }

    public MMCPosition getPositionById(long positionId) {
        return dao.getPositionById(positionId);
    }

    public MMCPosition updatePosition(MMCPosition position) {
        return dao.updatePosition(position);
    }

    public MMCPosition savePosition(MMCPosition position) {
        return dao.savePosition(position);
    }

    public MMCPosition saveOrUpdatePosition(MMCPosition position) {
        if(position.getId() != null) {
            return updatePosition(position);
        } else {
            return savePosition(position);
        }
    }
}
