package org.mmc.model.service;

import org.mmc.model.domain.Patient;
import org.mmc.model.filters.PatientsFilter;

import java.util.List;

/**
 * Created on: 2007-10-7
 *
 * @author Stoyo Venkov
 */
public interface PatientsService {
    /**
     * Finds patient by its id.
     * @param id The id to be searched for.
     * @return The patient's object if found, null - otherwise.
     */
    public Patient getPatientById(Long id);

    /**
     * Finds patients by filter.
     *
     * @param filter The patients' filter object.
     * @return List of all filtered patients.
     */
    public List getPatientsByFilter(PatientsFilter filter);
}
