package org.mmc.model.service;

import org.mmc.model.persistence.dao.ProbeTypesDao;
import org.mmc.model.filters.ProbeTypesFilter;
import org.mmc.model.domain.ProbeType;

import java.util.List;

/**
 * Created on: 2007-9-20
 *
 * @author Stoyo Venkov
 */
public class ProbeTypesDaoService implements ProbeTypesService {
    private ProbeTypesDao dao;

    public ProbeTypesDao getDao() {
        return dao;
    }

    public void setDao(ProbeTypesDao dao) {
        this.dao = dao;
    }

    public List getAllProbeTypes() {
        return dao.getAllProbeTypes();
    }

    public List getAllActive() {
        return dao.getAllActive();
    }

    public List getProbeTypesByFilter(ProbeTypesFilter filter) {
        return dao.getProbeTypesByFilter(filter);
    }

    public ProbeType getProbeTypeById(long probeTypeId) {
        return dao.getProbeTypeById(probeTypeId);
    }

    public ProbeType updateProbeType(ProbeType probeType) {
        return dao.updateProbeType(probeType);
    }

    public ProbeType saveProbeType(ProbeType probeType) {
        return dao.saveProbeType(probeType);
    }

    public ProbeType saveOrUpdateProbeType(ProbeType probeType) {
        if(probeType.getId() != null) {
            return updateProbeType(probeType);
        } else {
            return saveProbeType(probeType);
        }
    }
}
