package org.mmc.model.service;

import org.mmc.model.filters.ProjectsFilter;
import org.mmc.model.domain.Project;
import org.mmc.model.persistence.dao.ProjectsDao;

import java.util.List;

/**
 * Created on: 2007-9-19
 *
 * @author Stoyo Venkov
 */
public class ProjectsDaoService implements ProjectsService {
    private ProjectsDao dao;

    public ProjectsDao getDao() {
        return dao;
    }

    public void setDao(ProjectsDao dao) {
        this.dao = dao;
    }

    public List getAllProjects() {
        return dao.getAllProjects();
    }

    public List getAllActive() {
        return dao.getAllActive();
    }

    public List getProjectsByFilter(ProjectsFilter filter) {
        return dao.getProjectsByFilter(filter);
    }

    public Project getProjectById(long projectId) {
        return dao.getProjectById(projectId);
    }

    public Project updateProject(Project project) {
        return dao.updateProject(project);
    }

    public Project saveProject(Project project) {
        return dao.saveProject(project);
    }

    public Project saveOrUpdateProject(Project project) {
        if(project.getId() != null) {
            return updateProject(project);
        } else {
            return saveProject(project);
        }
    }
}
