package org.mmc.model.service;

import org.mmc.model.filters.UserFilter;
import org.mmc.model.domain.User;
import org.mmc.model.persistence.dao.UserDao;

import java.util.List;

/**
 * Created on: 2007-9-18
 *
 * @author Stoyo Venkov
 */
public class UsersDaoService implements UsersService {
    UserDao dao;
    MMCPositionsService positionsService;

    public UserDao getDao() {
        return dao;
    }

    public void setDao(UserDao dao) {
        this.dao = dao;
    }

    public MMCPositionsService getPositionsService() {
        return positionsService;
    }

    public void setPositionsService(MMCPositionsService positionsService) {
        this.positionsService = positionsService;
    }

    public List getUsersByFilter(UserFilter filter) {
        return dao.getUserByFilter(filter);
    }

    public User getUserById(long userId) {
        return dao.getUserById(userId);
    }

    public User getUserByUsernameAndPass(String password, String username) {
        return dao.getUserByUsernameAndPass(password, username);
    }

    public User updateUser(User user) {
        return dao.updateUser(user);
    }

    public User saveUser(User user) {
        return dao.saveUser(user);
    }

    public User saveOrUpdateUser(User user) {
        if(user.getId() != null) {
            return updateUser(user);
        } else {
            return saveUser(user);
        }
    }

    public List getAllUsers() {
        return dao.getAllUsers();
    }

    public List getAllRoles() {
        return dao.getAllRoles();
    }
}
