package org.mmc.utils;

import org.apache.log4j.Logger;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

/**
 * Created on: 2007-9-18
 *
 * @author Stoyo Venkov
 */
public class PasswordCrypt {
    private static Logger log = Logger.getLogger(PasswordCrypt.class.getName());
    private static final char[] DIGITS = {'0', '1', '2', '3', '4', '5', '6',
                                          '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'};

    /**
     * Creates a message digest (hash) from a string.
     * @param s
     * @return hex text representation of a byte array hash sum
     */
    public static String digest(String s) {
        MessageDigest md = null;
        try {
            md = MessageDigest.getInstance("MD5");
        } catch (NoSuchAlgorithmException e) {
            log.error("No such algorithm", e);
        }
        String hash = toHexString(md.digest(s.getBytes()));
        return hash;
    }

    /**
     * Converts a byte array to a hex string
     * @param data
     * @return
     */
    private static String toHexString(byte[] data) {
        StringBuffer buf = new StringBuffer(data.length * 2);
        for (int i = 0; i < data.length; ++i) {
            int hi = (data[i] & 0xf0) >> 4;
            buf.append(DIGITS[hi]);
            int lo = data[i] & 0xf;
            buf.append(DIGITS[lo]);
        }
        return buf.toString();
    }
}
