<%@ page import="org.mmc.utils.ResourcesUtils"%>
<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://java.sun.com/jstl/fmt" prefix="fmt" %>
<%@ taglib uri="http://java.sun.com/jstl/core" prefix="c" %>

<%
  String menuPathString = ResourcesUtils.getInstance().getString("label.menu.administration") + "->" +
      ResourcesUtils.getInstance().getString("label.menu.users");
%>
<jsp:include page="../includes/header.jsp">
  <jsp:param name="menuPath" value="<%=menuPathString%>"/>
</jsp:include>
<script type="text/javascript">
  <!--
    function onDataRowClicked(id) {
      document.location = "<%= request.getContextPath()%>"+"/editUser.do?userId="+id;
    }

    function doNewUser() {
      document.location = "<%= request.getContextPath()%>"+"/editUser.do";
    }
  //-->
</script>
<table class="content" cellpadding="0" cellspacing="0">
  <tr><td height="16"></td></tr>
  <tr><td class="headerCell"><fmt:message key="title.browseUsers"/></td></tr>
  <tr><td height="16"></td></tr>
  <tr>
    <td align="center">
      <html:form action="browseUsers.do?operation=filter">
      <table class="searchTable">
        <tr>
          <td class="leftNormalCell" width="18%"><fmt:message key="label.name"/></td>
          <td width="32%"><html:text property="firstName" styleClass="textBoxNormal"/></td>
          <td class="leftNormalCell" width="18%"><fmt:message key="label.userName"/></td>
          <td><html:text property="userName" styleClass="textBoxNormal"/></td>
        </tr>
        <tr>
          <td class="leftNormalCell"><fmt:message key="label.familyName"/></td>
          <td><html:text property="familyName" styleClass="textBoxNormal"/></td>
          <td class="leftNormalCell" width="18%"><fmt:message key="label.active"/></td>
          <td>
            <html:select property="active" styleClass="selectNormal">
              <html:option value=""><fmt:message key="label.select.all"/></html:option>
              <html:option value="1"><fmt:message key="label.select.active"/></html:option>
              <html:option value="0"><fmt:message key="label.select.inactive"/></html:option>
            </html:select>
          </td>
        </tr>
        <tr><td height="10" colspan="4"></td></tr>
        <tr><td colspan="4" align="right"><html:submit styleClass="buttonNormal"><fmt:message key="button.search"/></html:submit></td></tr>
      </table>
      </html:form>
    </td>
  </tr>
<c:if test="${param.operation != 'show'}">
  <tr><td height="16"></td></tr>
  <tr>
    <td>
      <table class="dataTable" align="center">
        <tr>
          <td class="dataHeaderCell" width="23%"><fmt:message key="label.name"/></td>
          <td class="dataHeaderCell" width="25%"><fmt:message key="label.familyName"/></td>
          <td class="dataHeaderCell" width="20%"><fmt:message key="label.phoneNumber"/></td>
          <td class="dataHeaderCell" width="25%"><fmt:message key="label.email"/></td>
          <td class="dataHeaderCell" width="7%"><fmt:message key="label.active"/></td>
        </tr>
        <c:choose>
          <c:when test="${empty tableData}">
            <tr class="dataRow"><td colspan="5"><fmt:message key="message.noDataFound"/></td></tr>
          </c:when>
          <c:otherwise>
            <c:forEach items="${tableData}" var="currUser">
              <tr class="dataRow" onClick="onDataRowClicked(<c:out value='${currUser.id}'/>)">
                <td><c:out value="${currUser.firstName}"/></td>
                <td><c:out value="${currUser.familyName}"/></td>
                <td><c:out value="${currUser.phoneNumber}"/></td>
                <td><c:out value="${currUser.email}"/></td>
                <td>
                  <c:choose>
                    <c:when test="${currUser.active}"><img src="images/active.gif" border="0" width="16" height="16"/></c:when>
                    <c:otherwise><img src="images/inactive.gif" border="0" width="16" height="16"/></c:otherwise>
                  </c:choose>
                </td>
              </tr>
            </c:forEach>
          </c:otherwise>
        </c:choose>
        <tr>
          <td class="dataHeaderCell" colspan="5">
            <c:if test="${searchFilter.previousPage}">
              <html:link action="browseUsers.do?operation=paging&pageOp=prev">
                <html:img page="/images/left6.gif" border="0" align="middle" />
              </html:link>
            </c:if>
            &nbsp;&nbsp;
            <c:if test="${searchFilter.nextPage}">
              <html:link action="browseUsers.do?operation=paging&pageOp=next">
                <html:img page="/images/right6.gif" border="0" align="middle" />
              </html:link>
            </c:if>
          </td>
        </tr>
      </table>
    </td>
  </tr>
</c:if>
  <tr><td height="16"></td></tr>
  <tr>
    <td>
      <table class="searchTable" align="center">
        <tr>
          <td class="leftNormalCell"><fmt:message key="label.explanation.newUser"/></td>
          <td align="right"><input type="button" name="newUser" value="<fmt:message key='button.newUser'/>" class="buttonAuto" onClick="doNewUser()"></td>
        </tr>
      </table>
    </td>
  </tr>
  <tr><td height="16"></td></tr>
</table>
<jsp:include page="../includes/footer.jsp"/>