<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://java.sun.com/jstl/fmt" prefix="fmt" %>
<%@ taglib uri="http://java.sun.com/jstl/core" prefix="c" %>
<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <title>MMC</title>
  <link rel="stylesheet" href="css/styles.css" />
  <script type="text/javascript" src="js/calendar.js"></script>
  <script type="text/javascript" src="js/common.js"></script>
  <!--[if IE]>
    <style type="text/css" media="screen">
      body {
        behavior: url(css/csshover.htc);
        font-size: 100%;
      }
      #menu ul li {float: left; width: 100%;}
      #menu ul li a {height: 1%;}

      #menu a, #menu h2 {
        font: bold 0.7em/1.4em arial, helvetica, sans-serif;
      }
    </style>
  <![endif]-->
  <script type="text/javascript">
    var RealTimeClock;
    var globalTimer = 1800;
    function updateClock() {
      if(globalTimer > 0) {
        globalTimer = globalTimer - 1;
        var seconds = globalTimer % 60;
        var minutes = (globalTimer - seconds) / 60;
        var result = (minutes < 10 ? "0" + minutes : minutes) + ":";
        result = result + (seconds < 10 ? "0" + seconds : seconds);
        if(globalTimer <= 600) {
          RealTimeClock.color = "#FF0000";
        }
        RealTimeClock.innerHTML = result;
        setTimeout("updateClock()", 1000);
      }
    }
    function startClock() {
      RealTimeClock = document.getElementById('RealTimeClock');
      RealTimeClock.innerHTML = "30:00";
      setTimeout("updateClock()", 1000);
    }

    function doOnLoad() {
      startClock();
    }
  </script>
</head>

<body onLoad="doOnLoad()">
  <table class="centertable" cellpadding="0" cellspacing="0">
    <tr><td style="font-size:18px; font-weight: bold"><fmt:message key="title.mainTitle"/></td></tr>
    <tr><td height="20"></td></tr>
  </table>
  <table class="centertable" cellpadding="0" cellspacing="0">
    <tr>
      <td class="corner"><img src="images/upLeft.gif" border="0" width="37" height="22"/></td>
      <td class="menuFill"></td>
      <td class="longEmpty" align="center"><c:if test="${not empty param.menuPath}"><c:out value="${param.menuPath}"/></c:if></td>
      <td class="menuFill" align="right"></td>
      <td class="corner"><img src="images/upRight.gif" border="0" width="37" height="22"/></td>
    </tr>
    <tr><td class="thinAnLong" colspan="5"></td></tr>
    <tr class="backEmpty">
      <td colspan="2"></td>
      <td align="left" style="font-size: 14px; font-family: Arial, Helvetica, sans-serif"><fmt:message key="title.user"/>&nbsp;<a href="#" class="oneLook"><c:out value="${loggedUserObj.firstName} ${loggedUserObj.familyName}"/></a></td>
      <td align="center"><font id="RealTimeClock" style="font-size:14px; font-family:Arial, Helvetica, sans-serif">30:00</font></td>
      <td align="center"><html:link action="appExit.do" styleClass="exit">изход</html:link></td>
    </tr>
    <tr><td class="thinnerAnLong" colspan="5"></td></tr>
  </table>
  <table class="centertable" cellpadding="0" cellspacing="0">
    <tr>
      <td class="leftCell">
       <table border="0" cellpadding="0" cellspacing="0" class="menutable">
          <tr>
            <td valign="top">
              <div id="menu">
                <ul>
                  <li>
                    <ul>
                      <li><a href="#" title=""><fmt:message key="label.menu.administration"/></a>
                        <ul>
                          <li><html:link action="browseUsers.do?operation=show" title="Тръсене/Добавяне/Радкция на потребители"><fmt:message key="label.menu.users"/></html:link></li>
                          <li><html:link action="/showParamGroups.do" title="Конфигурационни парамтри на системата"><fmt:message key="label.menu.confParams"/></html:link></li>
                          <li><a href="#" title="Номенклатури"><fmt:message key="label.menu.nomenclatures"/></a>
                            <ul>
                              <li><html:link action="browsePositions.do?operation=show" title=""><fmt:message key="label.menu.mmcPositions"/></html:link></li>
                              <li><html:link action="browseDiseases.do?operation=show" title=""><fmt:message key="label.menu.diseases"/></html:link></li>
                              <li><html:link action="browseEthnicGroups.do?operation=show" title=""><fmt:message key="label.menu.ethnicGroups"/></html:link></li>
                              <li><html:link action="browseProbeTypes.do?operation=show" title=""><fmt:message key="label.menu.probeTypes"/></html:link></li>
                              <li><html:link action="browseProjects.do?operation=show" title=""><fmt:message key="label.menu.projects"/></html:link></li>
                              <li><html:link action="browseCriteria.do?operation=show" title=""><fmt:message key="label.menu.criteria"/></html:link></li>
                            </ul>
                          </li>
                        </ul>
                      </li>
                    </ul>
                  </li>
                </ul>
                <ul>
                  <li>
                    <ul>
                      <li><a href="#" title=""><fmt:message key="label.menu.probeManagement"/></a>
                        <ul>
                          <li><html:link action="showProbeRegistration.do"><fmt:message key="label.menu.registerProbe"/></html:link></li>
                          <li><html:link action="browseProbes.do?operation=show"><fmt:message key="label.menu.browseProbes"/></html:link></li>
                          <li><a href="#"><fmt:message key="label.menu.registerContainer"/></a>
                            <ul>
                              <li><html:link action="registerTube.do"><fmt:message key="label.menu.tube"/></html:link></li>
                              <li><html:link action="registerRack.do"><fmt:message key="label.menu.rack"/></html:link></li>
                              <li><html:link action="registerPlate.do"><fmt:message key="label.menu.plate"/></html:link></li>
                              <li><html:link action="registerBatchGroup.do"><fmt:message key="label.menu.batchGroup"/></html:link></li>
                            </ul>
                          </li>
                        </ul>
                      </li>
                    </ul>
                  </li>
                </ul>
                <ul>
                  <li>
                    <ul>
                      <li><a href="#" title="">Пациенти</a>
                        <ul>
                          <li><a href="editPatient.html" title="Добавяне на нов пациент">Нов пациент</a></li>
                          <li><a href="browsePatients.html" title="Търсене на пациенти">Търсене на пациенти</a></li>
                          <li><a href="#" title="Търсене на семейство">Търсене на семейство</a></li>
                        </ul>
                      </li>
                    </ul>
                  </li>
                </ul>
                <ul>
                  <li>
                    <ul>
                      <li><html:link action="browseReports.do" title="Справки"><fmt:message key="label.menu.reports"/></html:link></li>
                    </ul>
                  </li>
                </ul>
              </div>
            </td>
          </tr>
          <tr><td class="leftCellMenuHeight"></td></tr>
        </table>
      </td>
      <td class="rightCell">
