<%@ page import="org.mmc.utils.ResourcesUtils"%>
<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://java.sun.com/jstl/fmt" prefix="fmt" %>
<%@ taglib uri="http://java.sun.com/jstl/core" prefix="c" %>

<%
  String menuPathString = ResourcesUtils.getInstance().getString("label.menu.probeManagement") + "->" +
      ResourcesUtils.getInstance().getString("label.menu.browseProbes");
%>
<jsp:include page="../includes/header.jsp">
  <jsp:param name="menuPath" value="<%=menuPathString%>"/>
</jsp:include>
<script type="text/javascript">
  <!--
    function doContinueProcess(prevStepId, projectId) {
      document.location = '<%=request.getContextPath()%>/showStepRegistration.do?prevStepId=' + prevStepId + "&projectId=" + projectId;
    }

    function doShowLocation(stepId) {
      document.location = '<%=request.getContextPath()%>/showLocations.do?stepId=' + stepId;
    }

    function doCancelProbe(probeId) {
      var cancelationReasonCtrl = document.getElementById('cancelationReasonId');
      if(cancelationReasonCtrl.value.length == 0) {
        window.alert('<fmt:message key="error.provideCancelationReason"/>');
      } else {
        document.location = '<%=request.getContextPath()%>/manageProbe.do?operation=cancel&reason=' + cancelationReasonCtrl.value + '&probeId=' + probeId;
      }
    }

    function doCompleteProbe(probeId) {
      document.location = '<%=request.getContextPath()%>/manageProbe.do?operation=complete&probeId=' + probeId;
    }

    function doMarkProbeAsSent(probeId) {
      document.location = '<%=request.getContextPath()%>/manageProbe.do?operation=markSent&probeId=' + probeId;
    }
  //-->
</script>
<table class="content" cellpadding="0" cellspacing="0">
  <tr><td height="16"></td></tr>
  <tr><td class="headerCell"><fmt:message key="title.manageProbe"/></td></tr>
  <jsp:include page="../includes/messages.jsp"/>
  <tr><td height="16"></td></tr>
  <tr>
    <td align="center">
      <table class="searchTable">
        <tr>
          <td class="leftNormalCell" width="18%"><fmt:message key="label.regNum"/></td>
          <td class="rightInfoCell" colspan="3"><c:out value="${managedProbe.id}"/></td>
        </tr>
        <tr>
          <td class="leftNormalCell" width="18%"><fmt:message key="label.registeredByF"/></td>
          <td class="rightInfoCell"><c:out value="${managedProbe.creator.fullName}"/></td>
          <td class="leftNormalCell" width="18%"><fmt:message key="label.registeredOnF"/></td>
          <td class="rightInfoCell"><fmt:formatDate pattern="dd.MM.yyyy" value="${managedProbe.registrationDate}"/></td>
        </tr>
        <tr><td height="8"></td></tr>
        <tr>
          <td class="leftNormalCell" width="18%"><fmt:message key="label.projects"/></td>
          <td colspan="3">
            <select class="selectAuto" size="4" disabled="true">
              <c:forEach items="${managedProbe.probeProjects}" var="probeProject">
                <option value="<c:out value='${probeProject.id}'/>"><c:out value="${probeProject.project.name}"/></option>
              </c:forEach>
            </select>
          </td>
        </tr>
        <tr><td height="8"></td></tr>
        <tr>
          <td class="leftNormalCell" width="18%"><fmt:message key="label.criteria"/></td>
          <td colspan="3">
            <table class="dataTableAuto" align="center" width="100%">
              <tr>
                <td class="dataHeaderCell" width="25%"><fmt:message key="label.code"/></td>
                <td class="dataHeaderCell"><fmt:message key="label.result"/></td>
              </tr>
              <c:forEach items="${managedProbe.probeCriteria}" var="probeCriterion">
                <tr class="dataRow">
                  <td><c:out value="${probeCriterion.criterion.code}"/></td>
                  <td><c:out value="${probeCriterion.result}"/></td>
                </tr>
              </c:forEach>
            </table>
          </td>
        </tr>
        <tr><td height="8"></td></tr>
        <tr>
          <td class="leftNormalCell" width="18%"><fmt:message key="label.completionDate"/></td>
          <td class="rightInfoCell" colspan="3">
            <c:choose>
              <c:when test="${not empty managedProbe.finishDate}"><fmt:formatDate pattern="dd.MM.yyyy" value="${managedProbe.finishDate}"/></c:when>
              <c:otherwise><input type="button" value="<fmt:message key='button.complete'/>" class="buttonAuto" onclick="doCompleteProbe(<c:out value='${managedProbe.id}'/>)"></c:otherwise>
            </c:choose>
          </td>
        </tr>
        <tr><td height="8"></td></tr>
<c:if test="${empty managedProbe.finishDate}">
        <tr>
          <td class="leftNormalCell" width="18%"><fmt:message key="label.cancel"/></td>
          <td class="rightInfoCell" colspan="3">
            <textarea wrap="soft" id="cancelationReasonId"><c:out value="${managedProbe.cancelationReason}"/></textarea>
            <c:choose>
              <c:when test="${managedProbe.canceled}"></c:when>
              <c:otherwise><input type="button" value="<fmt:message key='button.cancel'/>" class="buttonAuto" onclick="doCancelProbe(<c:out value='${managedProbe.id}'/>)"></c:otherwise>
            </c:choose>
          </td>
        </tr>
        <tr><td height="8"></td></tr>
</c:if>
<c:if test="${not empty managedProbe.finishDate || managedProbe.canceled}">
        <tr>
          <td class="leftNormalCell" width="18%"><fmt:message key="label.resultSent"/></td>
          <td class="rightInfoCell" colspan="3">
            <c:choose>
              <c:when test="${managedProbe.resultSent}"><fmt:message key="label.yes"/></c:when>
              <c:otherwise><input type="button" value="<fmt:message key='button.markResultSent'/>" class="buttonAuto" onclick="doMarkProbeAsSent(<c:out value='${managedProbe.id}'/>)"></c:otherwise>
            </c:choose>
          </td>
        </tr>
        <tr><td height="8"></td></tr>
</c:if>
        <tr>
          <td class="leftNormalCell" colspan="4"><fmt:message key="label.steps"/>:</td>
        </tr>
        <tr>
          <td colspan="4">
            <c:forEach items="${managedProbe.steps}" var="projectSteps">
              <table class="dataTableAuto" align="center" width="100%">
                <tr>
                  <td class="dataHeaderCell" colspan="8">
                    <c:choose>
                      <c:when test="${not empty projectSteps.projectName}"><fmt:message key="label.project"/>:<c:out value="${projectSteps.projectName}"/></c:when>
                      <c:otherwise><fmt:message key="label.common"/></c:otherwise>
                    </c:choose>
                  </td>
                </tr>
                <tr>
                  <td class="dataHeaderCell" width="10%"><fmt:message key="label.regNum"/></td>
                  <td class="dataHeaderCell" width="25%"><fmt:message key="label.kind"/></td>
                  <td class="dataHeaderCell" width="12%"><fmt:message key="label.startedOnF"/></td>
                  <td class="dataHeaderCell" width="12%"><fmt:message key="label.completedOnF"/></td>
                  <td class="dataHeaderCell" width="7%"><fmt:message key="label.successfulF"/></td>
                  <td class="dataHeaderCell" width="10%"><fmt:message key="label.parentStepRegNum"/></td>
                  <td class="dataHeaderCell" width="10%"><fmt:message key="label.nexStep"/></td>
                  <td class="dataHeaderCell"><fmt:message key="label.material"/></td>
                </tr>
                <c:forEach items="${projectSteps.steps}" var="step">
                  <tr class="dataRow">
                    <td><c:out value="${step.id}"/></td>
                    <td><c:out value="${step.nomenclatureStep.name}"/></td>
                    <td><fmt:formatDate pattern="dd.MM.yyyy" value="${step.startDate}"/></td>
                    <td><fmt:formatDate pattern="dd.MM.yyyy" value="${step.finishDate}"/></td>
                    <td>
                      <c:choose>
                        <c:when test="${step.successful}"><img src="images/active.gif" border="0" width="16" height="16"/></c:when>
                        <c:otherwise><img src="images/inactive.gif" border="0" width="16" height="16"/></c:otherwise>
                      </c:choose>
                    </td>
                    <td><c:out value="${step.parentStepId}"/></td>
                    <td>
                      <img src="images/continue4.gif" width="22" height="22" border="0" onclick="doContinueProcess('<c:out value="${step.id}"/>', '<c:out value="${projectSteps.projectId}"/>')"/>
                    </td>
                    <td>
                      <img src="images/location4.gif" width="22" height="22" border="0" onclick="doShowLocation('<c:out value="${step.id}"/>')"/>
                    </td>
                  </tr>
                </c:forEach>
              </table>
              <br/>
            </c:forEach>
          </td>
        </tr>
        <tr><td height="10" colspan="4"></td></tr>
      </table>
    </td>
  </tr>
  <tr><td height="16"></td></tr>
</table>
<jsp:include page="../includes/footer.jsp"/>