<%@ page import="org.mmc.utils.ResourcesUtils"%>
<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://java.sun.com/jstl/fmt" prefix="fmt" %>
<%@ taglib uri="http://java.sun.com/jstl/core" prefix="c" %>
<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <title>MMC</title>
  <link rel="stylesheet" href="css/styles.css" />
  <script type="text/javascript" src="js/common.js"></script>
  <script type="text/javascript" src="js/calendar.js"></script>

  <script type="text/javascript">
    function onDataRowClicked(pId, pName, pFamilyName, pInitials, pUniqueNumber) {
        var idField = window.opener.document.getElementById('patientIdField');
        if(idField != null) {
            idField.value = pId;
        }
        var firstNameField = window.opener.document.getElementById('patientFirstNameField');
        if(firstNameField != null) {
            firstNameField.value = pName;
        }
        var familyNameField = window.opener.document.getElementById('patientFamilyNameField');
        if(familyNameField != null) {
            familyNameField.value = pFamilyName;
        }
        var initialsField = window.opener.document.getElementById('patientInitialsField');
        if(initialsField != null) {
            initialsField.value = pInitials;
        }
        var uniqueNumberField = window.opener.document.getElementById('patientUniqueNumberField');
        if(uniqueNumberField != null) {
            uniqueNumberField.value = pUniqueNumber;
        }
        var fullNameField = window.opener.document.getElementById('patientFullNameField');
        if(fullNameField != null) {
            fullNameField.value = pName + ' ' + pFamilyName;
        }
        window.close();
    }
  </script>
</head>
<body>
<table class="content" cellpadding="0" cellspacing="0">
  <tr><td height="16"></td></tr>
  <tr><td class="headerCell"><fmt:message key="title.choosePatient"/></td></tr>
  <jsp:include page="../includes/messages.jsp"/>
  <tr><td height="16"></td></tr>
  <tr>
    <td align="center">
      <html:form action="choosePatient.do?operation=filter">
      <table class="searchTable">
        <tr>
          <td class="leftNormalCell" width="18%"><fmt:message key="label.name"/></td>
          <td width="36%" align="left"><html:text property="firstName" styleClass="textBoxNormal"/></td>
          <td class="leftNormalCell" width="18%"><fmt:message key="label.familyName"/></td>
          <td align="left"><html:text property="familyName" styleClass="textBoxNormal"/></td>
        </tr>
        <tr>
          <td class="leftNormalCell" width="18%"><fmt:message key="label.initials"/></td>
          <td align="left"><html:text property="initials" styleClass="textBoxNormal"/></td>
          <td class="leftNormalCell" width="18%"><fmt:message key="label.uniqueNumber"/></td>
          <td align="left"><html:text property="uniqueNumber" styleClass="textBoxNormal"/></td>
        </tr>
        <tr>
          <td class="leftNormalCell" width="18%"><fmt:message key="label.sex"/></td>
          <td align="left">
            <html:select property="sexId" styleClass="selectNormal">
              <html:option value=""></html:option>
              <html:optionsCollection property="sexesList" value="id" label="name"/>
            </html:select>
          </td>
          <td class="leftNormalCell" width="18%"><fmt:message key="label.ethnicGroup"/></td>
          <td align="left">
            <html:select property="ethnicGroupId" styleClass="selectNormal">
              <html:option value=""></html:option>
              <html:optionsCollection property="ethnicGroupsList" value="id" label="name"/>
            </html:select>
          </td>
        </tr>
        <tr>
          <td class="leftNormalCell" width="18%"><fmt:message key="label.registeredAfter"/></td>
          <td align="left"><html:text property="regFromDate" styleClass="textBoxDate" styleId="regFromDateField"/>&nbsp;<a href="javascript: popupCalendar(document.getElementById('regFromDateField'));"><img src="images/cal.gif" width="16" height="16" border="0" style="position: relative; top: 2px; cursor: pointer"></a></td>
          <td class="leftNormalCell" width="18%"><fmt:message key="label.registeredBefore"/></td>
          <td align="left"><html:text property="regToDate" styleClass="textBoxDate" styleId="regToDateField"/>&nbsp;<a href="javascript: popupCalendar(document.getElementById('regToDateField'));"><img src="images/cal.gif" width="16" height="16" border="0" style="position: relative; top: 2px; cursor: pointer"></a></td>
        </tr>
        <tr>
          <td class="leftNormalCell"><fmt:message key="label.birthData"/></td>
          <td align="left"><html:text property="familyName" styleClass="textBoxSmall"/>.<html:text property="familyName" styleClass="textBoxSmall"/>.<html:text property="familyName" styleClass="textBoxSmall"/></td>
          <td class="leftNormalCell"><fmt:message key="label.participatesInProjects"/></td>
          <td align="left">
            <html:select property="projectId" styleClass="selectNormal">
              <html:option value=""></html:option>
              <html:optionsCollection property="projectsList" value="id" label="name"/>
            </html:select>
          </td>
        </tr>
        <tr><td height="10" colspan="4"></td></tr>
        <tr><td colspan="4" align="right"><html:submit styleClass="buttonAuto"><fmt:message key="button.search"/></html:submit></td></tr>
      </table>
      </html:form>
    </td>
  </tr>
<c:if test="${param.operation != 'show'}">
  <tr><td height="16"></td></tr>
  <tr>
    <td>
      <table class="dataTable" align="center">
        <tr>
          <td class="dataHeaderCell" width="20%"><fmt:message key="label.name"/></td>
          <td class="dataHeaderCell" width="20%"><fmt:message key="label.familyName"/></td>
          <td class="dataHeaderCell" width="8%"><fmt:message key="label.initials"/></td>
          <td class="dataHeaderCell" width="20%"><fmt:message key="label.uniqueNumber"/></td>
          <td class="dataHeaderCell" width="15%"><fmt:message key="label.birthDataShort"/></td>
          <td class="dataHeaderCell" width="15%"><fmt:message key="label.registeredOn"/></td>
        </tr>
        <c:choose>
          <c:when test="${empty tableData}">
            <tr class="dataRow"><td colspan="6"><fmt:message key="message.noDataFound"/></td></tr>
          </c:when>
          <c:otherwise>
            <c:forEach items="${tableData}" var="patient">
              <tr class="dataRow" onClick="onDataRowClicked(<c:out value='${patient.id}'/>, '<c:out value="${patient.firstName}"/>', '<c:out value="${patient.familyName}"/>', '<c:out value="${patient.initials}"/>', '<c:out value="${patient.uniqueNumber}"/>')">
                <td><c:out value="${patient.firstName}"/></td>
                <td><c:out value="${patient.familyName}"/></td>
                <td><c:out value="${patient.initials}"/></td>
                <td><c:out value="${patient.uniqueNumber}"/></td>
                <td>
                  <c:choose>
                    <c:when test="${not empty patient.birthDay}"><c:out value="${patient.birthDay}"/></c:when>
                    <c:otherwise>xx</c:otherwise>
                  </c:choose>.
                  <c:choose>
                    <c:when test="${not empty patient.birthMonth}"><c:out value="${patient.birthMonth}"/></c:when>
                    <c:otherwise>xx</c:otherwise>
                  </c:choose>.
                  <c:choose>
                    <c:when test="${not empty patient.birthYear}"><c:out value="${patient.birthYear}"/></c:when>
                    <c:otherwise>xxxx</c:otherwise>
                  </c:choose>
                </td>
                <td><fmt:formatDate pattern="dd.MM.yyyy" value="${patient.registrationDate}"/></td>
              </tr>
            </c:forEach>
          </c:otherwise>
        </c:choose>
        <tr>
          <td class="dataHeaderCell" colspan="6">
            <c:if test="${searchFilter.previousPage}">
              <html:link action="choosePatient.do?operation=paging&pageOp=prev">
                <html:img page="/images/left6.gif" border="0" align="middle" />
              </html:link>
            </c:if>
            &nbsp;&nbsp;
            <c:if test="${searchFilter.nextPage}">
              <html:link action="choosePatient.do?operation=paging&pageOp=next">
                <html:img page="/images/right6.gif" border="0" align="middle" />
              </html:link>
            </c:if>
          </td>
        </tr>
      </table>
    </td>
  </tr>
</c:if>
  <tr><td height="16"></td></tr>
</table>
</body>
</html>