<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://java.sun.com/jstl/fmt" prefix="fmt" %>
<%@ taglib uri="http://java.sun.com/jstl/core" prefix="c" %>
<%@ taglib uri="http://jakarta.apache.org/taglibs/unstandard-1.0" prefix="un" %>

<un:useConstants var="GlobalAppConsts" className="org.mmc.web.Constants"/>

<jsp:include page="../includes/header.jsp"/>
<script type="text/javascript">
  <!--
    function onDataRowClicked(id) {
      document.location = "<%= request.getContextPath()%>"+"/editDisease.do?diseaseId="+id;
    }

    function doNewDisease() {
      document.location = "<%= request.getContextPath()%>"+"/editDisease.do";
    }
  //-->
</script>
<table class="content" cellpadding="0" cellspacing="0">
  <tr><td height="16"></td></tr>
  <tr><td class="headerCell"><fmt:message key="title.browseDiseases"/></td></tr>
  <tr><td height="16"></td></tr>
  <tr>
    <td align="center">
      <html:form action="browseDiseases.do?operation=filter">
      <table class="searchTable">
        <tr>
          <td class="leftNormalCell" width="18%"><fmt:message key="label.nameLong"/></td>
          <td colspan="3" align="left"><html:text property="name" styleClass="textBoxNormal"/></td>
        </tr>
        <tr>
          <td class="leftNormalCell"><fmt:message key="label.code"/></td>
          <td width="32%" align="left"><html:text property="code" styleClass="textBoxNormal"/></td>
          <td class="leftNormalCell" width="18%"><fmt:message key="label.activeFemale"/></td>
          <td>
            <html:select property="active" styleClass="selectNormal">
              <html:option value=""><fmt:message key="label.select.all"/></html:option>
              <html:option value="Y"><fmt:message key="label.select.active"/></html:option>
              <html:option value="N"><fmt:message key="label.select.inactive"/></html:option>
            </html:select>
          </td>
        </tr>
        <tr><td height="10" colspan="4"></td></tr>
        <tr><td colspan="4" align="right"><html:submit styleClass="buttonNormal"><fmt:message key="button.search"/></html:submit></td></tr>
      </table>
      </html:form>
    </td>
  </tr>
<c:if test="${param.operation != 'show'}">
  <tr><td height="16"></td></tr>
  <tr>
    <td>
      <table class="dataTable" align="center">
        <tr>
          <td class="dataHeaderCell" width="70%"><fmt:message key="label.nameLong"/></td>
          <td class="dataHeaderCell" width="23%"><fmt:message key="label.code"/></td>
          <td class="dataHeaderCell" width="7%"><fmt:message key="label.activeFemale"/></td>
        </tr>
        <c:choose>
          <c:when test="${empty tableData}">
            <tr class="dataRow"><td colspan="3"><fmt:message key="message.noDataFound"/></td></tr>
          </c:when>
          <c:otherwise>
            <c:forEach items="${tableData}" var="disease">
              <tr class="dataRow" onClick="onDataRowClicked(<c:out value='${disease.id}'/>)">
                <td><c:out value="${disease.name}"/></td>
                <td><c:out value="${disease.code}"/></td>
                <td>
                  <c:choose>
                    <c:when test="${disease.active}"><img src="images/active.gif" border="0" width="16" height="16"/></c:when>
                    <c:otherwise><img src="images/inactive.gif" border="0" width="16" height="16"/></c:otherwise>
                  </c:choose>
                </td>
              </tr>
            </c:forEach>
          </c:otherwise>
        </c:choose>
        <tr>
          <td class="dataHeaderCell" colspan="3">
            <c:if test="${searchFilter.previousPage}">
              <html:link action="search?operation=paging&pageOp=prev">
                <html:img page="/images/left6.gif" border="0" align="middle" />
              </html:link>
            </c:if>
            &nbsp;&nbsp;
            <c:if test="${searchFilter.nextPage}">
              <html:link action="search?operation=paging&pageOp=next">
                <html:img page="/images/right6.gif" border="0" align="middle" />
              </html:link>
            </c:if>
          </td>
        </tr>
      </table>
    </td>
  </tr>
</c:if>
  <tr><td height="16"></td></tr>
  <tr>
    <td>
      <table class="searchTable" align="center">
        <tr>
          <td class="leftNormalCell"><fmt:message key="label.explanation.newDisease"/></td>
          <td align="right"><input type="button" name="newUser" value="<fmt:message key='button.newDisease'/>" class="buttonAuto" onClick="doNewDisease()"></td>
        </tr>
      </table>
    </td>
  </tr>
  <tr><td height="16"></td></tr>
</table>
<jsp:include page="../includes/footer.jsp"/>