﻿// Title: Tigra Calendar
// URL: http://www.softcomplex.com/products/tigra_calendar/
// Version: 3.3 (American date format)
// Date: 09/01/2005 (mm/dd/yyyy)
// Note: Permission given to use this script in ANY kind of applications if
//    header lines are left unchanged.
// Note: Script consists of two files: calendar?.js and calendar.html

// if two digit year input dates after this year considered 20 century.
var NUM_CENTYEAR = 30;
// is time input control required by default
var BUL_TIMECOMPONENT = false;
// are year scrolling buttons required by default
var BUL_YEARSCROLL = true;

var calendars = [];
var RE_NUM = /^\-?\d+$/;

function calendar2(obj_target) {

	// assigning methods
	this.gen_date = cal_gen_date2;
	this.gen_time = cal_gen_time2;
	this.gen_tsmp = cal_gen_tsmp2;
	this.prs_date = cal_prs_date2;
	this.prs_time = cal_prs_time2;
	this.prs_tsmp = cal_prs_tsmp2;
	this.popup    = cal_popup2;

	// validate input parameters
	if (!obj_target)
		return cal_error("Error calling the calendar: no target control specified");
	if (obj_target.value == null)
		return cal_error("Error calling the calendar: parameter specified is not valid target control");
	this.target = obj_target;
	this.time_comp = BUL_TIMECOMPONENT;
	this.year_scroll = BUL_YEARSCROLL;
	
	// register in global collections
	this.id = calendars.length;
	calendars[this.id] = this;
}

function cal_popup2 (str_datetime) {
	if (str_datetime) {
		this.dt_current = this.prs_tsmp(str_datetime);
	}
	else {
		this.dt_current = this.prs_tsmp(this.target.value);
		this.dt_selected = this.dt_current;
	}
	if (!this.dt_current) return;

	var obj_calwindow = window.open(
		'calendar.do?datetime=' + this.dt_current.valueOf()+ '&id=' + this.id,
		'Calendar', 'width=200,height='+(this.time_comp ? 215 : 190)+
		',status=yes,resizable=yes,top=200,left=200,dependent=yes,alwaysRaised=yes'
	);
	obj_calwindow.opener = window;
	obj_calwindow.focus();
}

// timestamp generating function
function cal_gen_tsmp2 (dt_datetime) {
	return(this.gen_date(dt_datetime) + ' ' + this.gen_time(dt_datetime));
}

// date generating function
function cal_gen_date2 (dt_datetime) {
    var date = 		(dt_datetime.getDate() < 10 ? '0' : '') + dt_datetime.getDate() + "/"
		            + (dt_datetime.getMonth() < 9 ? '0' : '') + (dt_datetime.getMonth() + 1) + "/"
		            + dt_datetime.getFullYear()
	return toEuDate(date);
}
// time generating function
function cal_gen_time2 (dt_datetime) {
	return (
		(dt_datetime.getHours() < 10 ? '0' : '') + dt_datetime.getHours() + ":"
		+ (dt_datetime.getMinutes() < 10 ? '0' : '') + (dt_datetime.getMinutes()) + ":"
		+ (dt_datetime.getSeconds() < 10 ? '0' : '') + (dt_datetime.getSeconds())
	);
}

// timestamp parsing function
function cal_prs_tsmp2 (str_datetime) {
	// if no parameter specified return current timestamp
	if (!str_datetime)
		return (new Date());

	// if positive integer treat as milliseconds from epoch  (and if != 8 symbols, then it is a date)
	if (RE_NUM.exec(str_datetime) && str_datetime.length != 8)
		return new Date(str_datetime);
		
	// else treat as date in string format

	//cast from format YYYYMMDD to DD/MM/YYYY
    str_datetime = toCalendarDate(str_datetime);
	var arr_datetime = str_datetime.split(' ');
	return this.prs_time(arr_datetime[1], this.prs_date(arr_datetime[0]));
}

// date parsing function
function cal_prs_date2 (str_date, form_element) {

	var arr_date = str_date.split('/');

	if (arr_date.length != 3)
	{
		alert ("Невалидна стойност на датата: '" + str_date + "'.\nТрябва да бъде във формат ДД/ММ/ГГГГ.");
		form_element.focus();
		return;
	}
	if (!arr_date[0])
	{
		alert ("Невалидна стойност на датата: '" + str_date + "'.\nЛипсва полето за ден от месеца.");
		form_element.focus();
		return;
	}
	if (!RE_NUM.exec(arr_date[0]))
	{
		alert ("Невалиден ден от месеца: '" + arr_date[0] + "'.\nПозволени са само цели числа без знак.");
		form_element.focus();
		return;
	}
	if (!arr_date[1])
	{
		alert ("Невалидна стойност на датата: '" + str_date + "'.\nЛипсва полето за месец.");
		form_element.focus();
		return;
	}
	if (!RE_NUM.exec(arr_date[1]))
	{
		alert ("Невалиден месец: '" + arr_date[1] + "'.\nПозволени са само цели числа без знак.");
		form_element.focus();
		return;
	}
	if (!arr_date[2])
	{
		alert ("Невалидна стойност на датата: '" + str_date + "'.\nЛипсва полето за година.");
		form_element.focus();
		return;
	}
	if (!RE_NUM.exec(arr_date[2]))
	{
		alert ("Невалидна година: '" + arr_date[2] + "'.\nПозволени са само цели числа без знак.");
		form_element.focus();
		return;
	}

	var dt_date = new Date();
	dt_date.setDate(1);

	if (arr_date[1] < 1 || arr_date[1] > 12)
	{
		alert ("Невалиден месец: '" + arr_date[1] + "'.\nПозволеният интервал е 01-12.");
		form_element.focus();
		return;
	}
	dt_date.setMonth(arr_date[1]-1);

	if (arr_date[2] < 100) arr_date[2] = Number(arr_date[2]) + (arr_date[2] < NUM_CENTYEAR ? 2000 : 1900);
	dt_date.setFullYear(arr_date[2]);

	var dt_numdays = new Date(arr_date[2], arr_date[1], 0);
	dt_date.setDate(arr_date[0]);
	if (dt_date.getMonth() != (arr_date[1]-1))
	{
		alert ("Невалиден ден от месеца: '" + arr_date[0] + "'.\nПозволеният интервал е 01-"+dt_numdays.getDate()+".");
		form_element.focus();
		return;
	}

	return (dt_date)
}

// time parsing function
function cal_prs_time2 (str_time, dt_date) {

	if (!dt_date) return null;
	var arr_time = String(str_time ? str_time : '').split(':');

	if (!arr_time[0]) dt_date.setHours(0);
	else if (RE_NUM.exec(arr_time[0])) 
		if (arr_time[0] < 24) dt_date.setHours(arr_time[0]);
		else return cal_error ("Invalid hours value: '" + arr_time[0] + "'.\nAllowed range is 00-23.");
	else return cal_error ("Invalid hours value: '" + arr_time[0] + "'.\nAllowed values are unsigned integers.");
	
	if (!arr_time[1]) dt_date.setMinutes(0);
	else if (RE_NUM.exec(arr_time[1]))
		if (arr_time[1] < 60) dt_date.setMinutes(arr_time[1]);
		else return cal_error ("Invalid minutes value: '" + arr_time[1] + "'.\nAllowed range is 00-59.");
	else return cal_error ("Invalid minutes value: '" + arr_time[1] + "'.\nAllowed values are unsigned integers.");

	if (!arr_time[2]) dt_date.setSeconds(0);
	else if (RE_NUM.exec(arr_time[2]))
		if (arr_time[2] < 60) dt_date.setSeconds(arr_time[2]);
		else return cal_error ("Invalid seconds value: '" + arr_time[2] + "'.\nAllowed range is 00-59.");
	else return cal_error ("Invalid seconds value: '" + arr_time[2] + "'.\nAllowed values are unsigned integers.");

	dt_date.setMilliseconds(0);
	return dt_date;
}

function cal_error (str_message) {
	alert (str_message);
	return null;
}

function toCalendarDate(euDate) {
    var year = euDate.substr(6, 4);
    var month = euDate.substr(3, 2);
    var day = euDate.substr(0, 2);
    return day + "/" + month + "/" + year;

}

function toEuDate(calendarDate) {
    var arr_date = calendarDate.split('/');
    return arr_date[0] + "." + arr_date[1] + "." + arr_date[2];

}

function popupCalendar(self)
{
    var cal = new calendar2(self);
	cal.year_scroll = true;
    cal.time_comp = false;
    cal.popup();
}

