<%@ page import="org.mmc.utils.ResourcesUtils"%>
<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://java.sun.com/jstl/fmt" prefix="fmt" %>
<%@ taglib uri="http://java.sun.com/jstl/core" prefix="c" %>
<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <title>MMC</title>
  <link rel="stylesheet" href="css/styles.css" />
  <script type="text/javascript" src="js/common.js"></script>
  <script type="text/javascript" src="js/calendar.js"></script>

  <script type="text/javascript">
    function onDataRowClicked(pId) {
        var idField = window.opener.document.getElementById('stepIdField');
        if(idField != null) {
            idField.value = pId;
        }
        window.close();
    }
  </script>
</head>
<body>
<table class="content" cellpadding="0" cellspacing="0">
  <tr><td height="16"></td></tr>
  <tr><td class="headerCell"><fmt:message key="title.choosePatient"/></td></tr>
  <jsp:include page="../includes/messages.jsp"/>
  <tr><td height="16"></td></tr>
  <tr>
    <td>
      <table class="searchTable" align="center">
        <tr>
          <td class="leftNormalCell" colspan="4"><fmt:message key="label.steps"/>:</td>
        </tr>
        <tr>
          <td colspan="4">
            <c:forEach items="${managedProbe.steps}" var="projectSteps">
              <table class="dataTableAuto" align="center" width="100%">
                <tr>
                  <td class="dataHeaderCell" colspan="6">
                    <c:choose>
                      <c:when test="${not empty projectSteps.projectName}"><fmt:message key="label.project"/>:<c:out value="${projectSteps.projectName}"/></c:when>
                      <c:otherwise><fmt:message key="label.common"/></c:otherwise>
                    </c:choose>
                  </td>
                </tr>
                <tr>
                  <td class="dataHeaderCell" width="10%"><fmt:message key="label.regNum"/></td>
                  <td class="dataHeaderCell" width="25%"><fmt:message key="label.kind"/></td>
                  <td class="dataHeaderCell" width="12%"><fmt:message key="label.startedOnF"/></td>
                  <td class="dataHeaderCell" width="12%"><fmt:message key="label.completedOnF"/></td>
                  <td class="dataHeaderCell" width="7%"><fmt:message key="label.successfulF"/></td>
                  <td class="dataHeaderCell" width="10%"><fmt:message key="label.parentStepRegNum"/></td>
                </tr>
                <c:forEach items="${projectSteps.steps}" var="step">
                  <tr class="dataRow" onclick="onDataRowClicked(<c:out value="${step.id}"/>)" >
                    <td><c:out value="${step.id}"/></td>
                    <td><c:out value="${step.nomenclatureStep.name}"/></td>
                    <td><fmt:formatDate pattern="dd.MM.yyyy" value="${step.startDate}"/></td>
                    <td><fmt:formatDate pattern="dd.MM.yyyy" value="${step.finishDate}"/></td>
                    <td>
                      <c:choose>
                        <c:when test="${step.successful}"><img src="images/active.gif" border="0" width="16" height="16"/></c:when>
                        <c:otherwise><img src="images/inactive.gif" border="0" width="16" height="16"/></c:otherwise>
                      </c:choose>
                    </td>
                    <td><c:out value="${step.parentStepId}"/></td>
                  </tr>
                </c:forEach>
              </table>
              <br/>
            </c:forEach>
          </td>
        </tr>
      </table>
    </td>
  </tr>
  <tr><td height="16"></td></tr>
</table>
</body>
</html>