<%@ page import="org.mmc.utils.ResourcesUtils"%>
<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://java.sun.com/jstl/fmt" prefix="fmt" %>
<%@ taglib uri="http://java.sun.com/jstl/core" prefix="c" %>
<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <title>MMC</title>
  <link rel="stylesheet" href="css/styles.css" />
  <script type="text/javascript" src="js/common.js"></script>
  <script type="text/javascript" src="js/calendar.js"></script>

  <script type="text/javascript">
    function onDataRowClicked(rId, rRegDate) {
        var idField = window.opener.document.getElementById('requestIdField');
        if(idField != null) {
            idField.value = rId;
        }
        var regNumField = window.opener.document.getElementById('requestRegNumField');
        if(regNumField != null) {
            regNumField.value = rId;
        }
        var regDateField = window.opener.document.getElementById('requestRegisteredOnField');
        if(regDateField != null) {
            regDateField.value = rRegDate;
        }

        window.close();
    }
    function doChoosePatient() {
      openWin('_blank', '<%=request.getContextPath()%>/choosePatient.do?operation=show', 500, 800, 'top=100,left=100');
    }
  </script>
</head>
<body>
<table class="content" cellpadding="0" cellspacing="0">
  <tr><td height="16"></td></tr>
  <tr><td class="headerCell"><fmt:message key="title.chooseRequest"/></td></tr>
  <jsp:include page="../includes/messages.jsp"/>
  <tr><td height="16"></td></tr>
  <tr>
    <td align="center">
      <html:form action="chooseRequest.do?operation=filter">
      <table class="searchTable">
        <tr>
          <td class="leftNormalCell" width="18%"><fmt:message key="label.regNum"/></td>
          <td width="36%" align="left"><html:text property="id" styleClass="textBoxNormal"/></td>
          <td colspan="2">&nbsp;</td>
        </tr>
        <tr>
          <td class="leftNormalCell" width="18%"><fmt:message key="label.registeredAfterN"/></td>
          <td align="left"><html:text property="regFromDate" styleClass="textBoxDate" styleId="regFromDateField"/>&nbsp;<a href="javascript: popupCalendar(document.getElementById('regFromDateField'));"><img src="images/cal.gif" width="16" height="16" border="0" style="position: relative; top: 2px; cursor: pointer"></a></td>
          <td class="leftNormalCell" width="18%"><fmt:message key="label.registeredBeforeN"/></td>
          <td align="left"><html:text property="regToDate" styleClass="textBoxDate" styleId="regToDateField"/>&nbsp;<a href="javascript: popupCalendar(document.getElementById('regToDateField'));"><img src="images/cal.gif" width="16" height="16" border="0" style="position: relative; top: 2px; cursor: pointer"></a></td>
        </tr>
        <tr>
          <td class="leftNormalCell" width="18%"><fmt:message key="label.patient"/></td>
          <td align="left">
            <html:text property="patientNameInfo" styleClass="textBoxWithLov" readonly="true" styleId="patientFullNameField"/>&nbsp;<input type="button" class="buttonBrowse" value="..." onClick="doChoosePatient()"/>
            <html:hidden property="patientId" styleId="patientIdField"/>
          </td>
          <td class="leftNormalCell" width="18%"><fmt:message key="label.user"/></td>
          <td align="left">
            <html:select property="userId">
              <html:option value=""></html:option>
              <html:optionsCollection property="usersList" value="id" label="fullName"/>
            </html:select>
          </td>
        </tr>
        <tr><td height="10" colspan="4"></td></tr>
        <tr><td colspan="4" align="right"><html:submit styleClass="buttonAuto"><fmt:message key="button.search"/></html:submit></td></tr>
      </table>
      </html:form>
    </td>
  </tr>
<c:if test="${param.operation != 'show'}">
  <tr><td height="16"></td></tr>
  <tr>
    <td>
      <table class="dataTable" align="center">
        <tr>
          <td class="dataHeaderCell" width="17%"><fmt:message key="label.regNum"/></td>
          <td class="dataHeaderCell" width="36%"><fmt:message key="label.analysisFor"/></td>
          <td class="dataHeaderCell" width="15%"><fmt:message key="label.enteredBy"/></td>
          <td class="dataHeaderCell" width="15%"><fmt:message key="label.enteredOn"/></td>
        </tr>
        <c:choose>
          <c:when test="${empty tableData}">
            <tr class="dataRow"><td colspan="4"><fmt:message key="message.noDataFound"/></td></tr>
          </c:when>
          <c:otherwise>
            <c:forEach items="${tableData}" var="analysisRequest">
              <tr class="dataRow" onClick="onDataRowClicked(<c:out value='${analysisRequest.id}'/>, <c:out value='${analysisRequest.registrationDate}'/>)">
                <td><c:out value="${analysisRequest.patient.id}"/></td>
                <td><c:out value="${analysisRequest.analysisReason}"/></td>
                <td><c:out value="${analysisRequest.creator.fullName}"/></td>
                <td><fmt:formatDate pattern="dd.MM.yyyy" value="${analysisRequest.registrationDate}"/></td>
              </tr>
            </c:forEach>
          </c:otherwise>
        </c:choose>
        <tr>
          <td class="dataHeaderCell" colspan="4">
            <c:if test="${searchFilter.previousPage}">
              <html:link action="chooseRequest.do?operation=paging&pageOp=prev">
                <html:img page="/images/left6.gif" border="0" align="middle" />
              </html:link>
            </c:if>
            &nbsp;&nbsp;
            <c:if test="${searchFilter.nextPage}">
              <html:link action="chooseRequest.do?operation=paging&pageOp=next">
                <html:img page="/images/right6.gif" border="0" align="middle" />
              </html:link>
            </c:if>
          </td>
        </tr>
      </table>
    </td>
  </tr>
</c:if>
  <tr><td height="16"></td></tr>
</table>
</body>
</html>