package org.mmc.web.actions;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForm;
import org.apache.log4j.Logger;
import org.mmc.web.Constants;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.Serializable;

/**
 * Created on: 2007-9-9
 *
 * @author Stoyo Venkov
 */
public abstract class BaseAction extends Action {
    protected Logger logger = Logger.getLogger(this.getClass());

    protected abstract ActionForward doBaseExecute(ActionMapping actionMapping,
                                 ActionForm actionForm,
                                 HttpServletRequest httpServletRequest,
                                 HttpServletResponse httpServletResponse)
            throws Exception;

    public ActionForward execute(ActionMapping actionMapping,
                                 ActionForm actionForm,
                                 HttpServletRequest httpServletRequest,
                                 HttpServletResponse httpServletResponse)
            throws Exception {

        try {
            return doBaseExecute(actionMapping, actionForm,
                    httpServletRequest, httpServletResponse);
        } catch (Exception e) {
            logger.error("Exception", e);
            httpServletRequest.setAttribute(Constants.ERROR_OBJECT, e);
            return actionMapping.findForward(Constants.GLOBAL_FORWARD_ERROR);
        }
    }

    protected void saveObjectInSession(HttpServletRequest request, Serializable object, String attrName) {
        request.getSession().setAttribute(attrName, object);
    }

    protected Serializable getObjectFromSession(HttpServletRequest request, String attrName) {
        return (Serializable) request.getSession().getAttribute(attrName);
    }
}
