package org.mmc.web.actions.administration;

import org.mmc.web.actions.BaseSecurityAction;
import org.mmc.web.forms.administration.EditProjectForm;
import org.mmc.model.service.ProjectsService;
import org.mmc.model.service.DiseasesService;
import org.mmc.model.domain.Disease;

import java.util.List;
import java.util.ArrayList;

/**
 * Created on: 2007-9-20
 *
 * @author Stoyo Venkov
 */
public abstract class BaseProjectAction extends BaseSecurityAction {
    protected ProjectsService service;
    protected DiseasesService diseaseService;

    public BaseProjectAction(ProjectsService service, DiseasesService diseaseService) {
        this.service = service;
        this.diseaseService = diseaseService;
    }

    protected void setUpDiseases(EditProjectForm form) {
        List all = diseaseService.getAllActive();
        form.setDiseases(all);

        String[] diseaseIds = form.getDiseaseIds();
        List chosenList = getChosen(diseaseIds, all);
        form.setDiseases(chosenList);
        List availableList = getAvailable(diseaseIds, all);
        form.setAvailableDiseases(availableList);
    }

    protected List getChosen(String[] diseaseIds, List all) {
        List result = new ArrayList();
        if (diseaseIds == null) {
            return result;
        }

        for (int i = 0; i < all.size(); i++) {
            Disease disease = (Disease) all.get(i);

            for (int j = 0; j < diseaseIds.length; j++) {
                Long id = disease.getId();
                String strId = id.toString();
                String otherId = diseaseIds[j];

                if (otherId.equals(strId)) {
                    result.add(disease);
                }
            }
        }

        return result;
    }

    protected List getAvailable(String[] diseaseIds, List all){
        if (diseaseIds == null) {
            return new ArrayList(all);
        }

        List result = new ArrayList();

        for(int i = 0; i < all.size(); i++) {
            Disease disease = (Disease) all.get(i);
            int j;
            for(j = 0; j < diseaseIds.length; j++) {
                String userRoleId = diseaseIds[j];
                if(disease.getId().equals(new Long(userRoleId))) {
                    break;
                }
            }
            if(j == diseaseIds.length) {
                result.add(disease);
            }
        }

        return result;
    }
}
