package org.mmc.web.actions.administration;

import org.mmc.web.actions.search.BaseSearchAction;
import org.mmc.web.Constants;
import org.mmc.web.forms.administration.CriterionForm;
import org.mmc.model.filters.BasePageFilter;
import org.mmc.model.filters.CriteriaFilter;
import org.mmc.model.service.CriteriaService;
import org.apache.struts.action.ActionForm;

import java.util.List;

/**
 * Created on: 2007-9-20
 *
 * @author Stoyo Venkov
 */
public class BrowseCriteriaAction extends BaseSearchAction {
    private CriteriaService service;

    public BrowseCriteriaAction(CriteriaService service) {
        this.service = service;
    }

    protected BasePageFilter constructFilter() {
        CriteriaFilter filter = new CriteriaFilter(Constants.PAGE_SIZE);
        return filter;
    }

    protected void populateFilter(BasePageFilter filter, ActionForm actionForm) {
        CriterionForm form = (CriterionForm) actionForm;
        CriteriaFilter result = (CriteriaFilter) filter;
        form.initializeFilterObject(result);
    }

    protected void populateForm(ActionForm actionForm, BasePageFilter filter) {
        CriterionForm form = (CriterionForm) actionForm;
        CriteriaFilter result = (CriteriaFilter) filter;
        form.initializFormFromFilter(result);
    }

    protected List exposeDbData(BasePageFilter filter) {
        CriteriaFilter groupsFilter = (CriteriaFilter) filter;

        List results = service.getCriteriaByFilter(groupsFilter);
        return results;
    }

}
