package org.mmc.web.actions.administration;

import org.mmc.web.actions.search.BaseSearchAction;
import org.mmc.web.Constants;
import org.mmc.web.forms.administration.DiseaseForm;
import org.mmc.model.service.DiseasesService;
import org.mmc.model.filters.BasePageFilter;
import org.mmc.model.filters.DiseasesFilter;
import org.apache.struts.action.ActionForm;

import java.util.List;

/**
 * Created on: 2007-9-9
 *
 * @author Stoyo Venkov
 */
public class BrowseDiseasesAction extends BaseSearchAction {
    private DiseasesService service;

    public BrowseDiseasesAction(DiseasesService service) {
        this.service = service;
    }

    protected BasePageFilter constructFilter() {
        DiseasesFilter filter = new DiseasesFilter(Constants.PAGE_SIZE);
        return filter;
    }

    protected void populateFilter(BasePageFilter filter, ActionForm actionForm) {
        DiseaseForm form = (DiseaseForm) actionForm;
        DiseasesFilter result = (DiseasesFilter) filter;
        form.initializeFilterObject(result);
    }

    protected void populateForm(ActionForm actionForm, BasePageFilter filter) {
        DiseaseForm form = (DiseaseForm) actionForm;
        DiseasesFilter result = (DiseasesFilter) filter;
        form.initializFormFromFilter(result);
    }

    protected List exposeDbData(BasePageFilter filter) {
        DiseasesFilter disessesFilter = (DiseasesFilter) filter;

        List results = service.getDiseasesByFilter(disessesFilter);
        return results;
    }
}
