package org.mmc.web.actions.administration;

import org.mmc.web.actions.search.BaseSearchAction;
import org.mmc.web.Constants;
import org.mmc.web.forms.administration.EthnicGroupForm;
import org.mmc.model.filters.BasePageFilter;
import org.mmc.model.filters.EthnicGroupFilter;
import org.mmc.model.service.EthnicGroupsService;
import org.apache.struts.action.ActionForm;

import java.util.List;

/**
 * Created on: 2007-9-17
 *
 * @author Stoyo Venkov
 */
public class BrowseEthnicGroupsAction extends BaseSearchAction {
    private EthnicGroupsService service;

    public BrowseEthnicGroupsAction(EthnicGroupsService service) {
        this.service = service;
    }

    protected BasePageFilter constructFilter() {
        EthnicGroupFilter filter = new EthnicGroupFilter(Constants.PAGE_SIZE);
        return filter;
    }

    protected void populateFilter(BasePageFilter filter, ActionForm actionForm) {
        EthnicGroupForm form = (EthnicGroupForm) actionForm;
        EthnicGroupFilter result = (EthnicGroupFilter) filter;
        form.initializeFilterObject(result);
    }

    protected void populateForm(ActionForm actionForm, BasePageFilter filter) {
        EthnicGroupForm form = (EthnicGroupForm) actionForm;
        EthnicGroupFilter result = (EthnicGroupFilter) filter;
        form.initializFormFromFilter(result);
    }

    protected List exposeDbData(BasePageFilter filter) {
        EthnicGroupFilter groupsFilter = (EthnicGroupFilter) filter;

        List results = service.getEthnicGroupsByFilter(groupsFilter);
        return results;
    }

}
