package org.mmc.web.actions.administration;

import org.mmc.web.actions.search.BaseSearchAction;
import org.mmc.web.Constants;
import org.mmc.web.forms.administration.PositionForm;
import org.mmc.model.filters.BasePageFilter;
import org.mmc.model.filters.PositionFilter;
import org.mmc.model.service.MMCPositionsService;
import org.apache.struts.action.ActionForm;

import java.util.List;

/**
 * Created on: 2007-9-16
 *
 * @author Stoyo Venkov
 */
public class BrowsePositionsAction extends BaseSearchAction {
    private MMCPositionsService service;

    public BrowsePositionsAction(MMCPositionsService service) {
        this.service = service;
    }

    protected BasePageFilter constructFilter() {
        PositionFilter filter = new PositionFilter(Constants.PAGE_SIZE);
        return filter;
    }

    protected void populateFilter(BasePageFilter filter, ActionForm actionForm) {
        PositionForm form = (PositionForm) actionForm;
        PositionFilter result = (PositionFilter) filter;
        form.initializeFilterObject(result);
    }

    protected void populateForm(ActionForm actionForm, BasePageFilter filter) {
        PositionForm form = (PositionForm) actionForm;
        PositionFilter result = (PositionFilter) filter;
        form.initializFormFromFilter(result);
    }

    protected List exposeDbData(BasePageFilter filter) {
        PositionFilter disessesFilter = (PositionFilter) filter;

        List results = service.getPositionsByFilter(disessesFilter);
        return results;
    }
}
