package org.mmc.web.actions.administration;

import org.mmc.web.actions.search.BaseSearchAction;
import org.mmc.web.Constants;
import org.mmc.web.forms.administration.ProbeTypeForm;
import org.mmc.model.filters.BasePageFilter;
import org.mmc.model.filters.ProbeTypesFilter;
import org.mmc.model.service.ProbeTypesService;
import org.apache.struts.action.ActionForm;

import java.util.List;

/**
 * Created on: 2007-9-20
 *
 * @author Stoyo Venkov
 */
public class BrowseProbeTypesAction extends BaseSearchAction {
    private ProbeTypesService service;

    public BrowseProbeTypesAction(ProbeTypesService service) {
        this.service = service;
    }

    protected BasePageFilter constructFilter() {
        ProbeTypesFilter filter = new ProbeTypesFilter(Constants.PAGE_SIZE);
        return filter;
    }

    protected void populateFilter(BasePageFilter filter, ActionForm actionForm) {
        ProbeTypeForm form = (ProbeTypeForm) actionForm;
        ProbeTypesFilter result = (ProbeTypesFilter) filter;
        form.initializeFilterObject(result);
    }

    protected void populateForm(ActionForm actionForm, BasePageFilter filter) {
        ProbeTypeForm form = (ProbeTypeForm) actionForm;
        ProbeTypesFilter result = (ProbeTypesFilter) filter;
        form.initializFormFromFilter(result);
    }

    protected List exposeDbData(BasePageFilter filter) {
        ProbeTypesFilter groupsFilter = (ProbeTypesFilter) filter;

        List results = service.getProbeTypesByFilter(groupsFilter);
        return results;
    }

}
