package org.mmc.web.actions.administration;

import org.mmc.web.actions.search.BaseSearchAction;
import org.mmc.web.Constants;
import org.mmc.web.forms.administration.SearchProjectForm;
import org.mmc.model.filters.BasePageFilter;
import org.mmc.model.filters.ProjectsFilter;
import org.mmc.model.service.ProjectsService;
import org.apache.struts.action.ActionForm;

import java.util.List;

/**
 * Created on: 2007-9-19
 *
 * @author Stoyo Venkov
 */
public class BrowseProjectsAction extends BaseSearchAction {
    ProjectsService service;

    public BrowseProjectsAction(ProjectsService service) {
        this.service = service;
    }

    protected BasePageFilter constructFilter() {
        ProjectsFilter filter = new ProjectsFilter(Constants.PAGE_SIZE);
        return filter;
    }

    protected void populateFilter(BasePageFilter filter, ActionForm actionForm) {
        SearchProjectForm form = (SearchProjectForm) actionForm;
        ProjectsFilter result = (ProjectsFilter) filter;
        form.initializeFilterObject(result);
    }

    protected void populateForm(ActionForm actionForm, BasePageFilter filter) {
        SearchProjectForm form = (SearchProjectForm) actionForm;
        ProjectsFilter result = (ProjectsFilter) filter;
        form.initializFormFromFilter(result);
    }

    protected List exposeDbData(BasePageFilter filter) {
        return service.getProjectsByFilter((ProjectsFilter) filter);
    }
}
