package org.mmc.web.actions.administration;

import org.mmc.web.actions.search.BaseSearchAction;
import org.mmc.web.Constants;
import org.mmc.web.forms.administration.SearchUserForm;
import org.mmc.model.filters.BasePageFilter;
import org.mmc.model.filters.UserFilter;
import org.mmc.model.service.UsersService;
import org.apache.struts.action.ActionForm;

import java.util.List;

/**
 * Created on: 2007-9-18
 *
 * @author Stoyo Venkov
 */
public class BrowseUsersAction extends BaseSearchAction {
    UsersService service;

    public BrowseUsersAction(UsersService service) {
        this.service = service;
    }

    protected BasePageFilter constructFilter() {
        UserFilter filter = new UserFilter(Constants.PAGE_SIZE);
        return filter;
    }

    protected void populateFilter(BasePageFilter filter, ActionForm actionForm) {
        SearchUserForm form = (SearchUserForm) actionForm;
        UserFilter result = (UserFilter) filter;
        form.initializeFilterObject(result);
    }

    protected void populateForm(ActionForm actionForm, BasePageFilter filter) {
        SearchUserForm form = (SearchUserForm) actionForm;
        UserFilter result = (UserFilter) filter;
        form.initializFormFromFilter(result);
    }

    protected List exposeDbData(BasePageFilter filter) {
        return service.getUsersByFilter((UserFilter) filter);
    }
}
