package org.mmc.web.actions.administration;

import org.mmc.web.actions.BaseSecurityAction;
import org.mmc.web.Constants;
import org.mmc.web.forms.administration.CriterionForm;
import org.mmc.model.service.CriteriaService;
import org.mmc.model.domain.Criterion;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForm;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Created on: 2007-9-20
 *
 * @author Stoyo Venkov
 */
public class EditCriterionAction extends BaseSecurityAction {
    private CriteriaService service;

    public EditCriterionAction(CriteriaService service) {
        this.service = service;
    }

    protected ActionForward doExecute(ActionMapping actionMapping,
                                      ActionForm actionForm,
                                      HttpServletRequest httpServletRequest,
                                      HttpServletResponse httpServletResponse)
            throws Exception {

        ActionForward result = null;
        String criterionIdStr = httpServletRequest.getParameter("criterionId");
        if(criterionIdStr != null) {
            result = loadExisting(actionMapping, actionForm, httpServletRequest, criterionIdStr);
        } else {
            result = loadNew(actionMapping, actionForm, httpServletRequest);
        }

        return result;
    }

    private ActionForward loadNew(ActionMapping actionMapping,
                                  ActionForm actionForm,
                                  HttpServletRequest httpServletRequest)
            throws Exception {

        return actionMapping.findForward(Constants.FORWARD_SUCCESS);
    }

    private ActionForward loadExisting(ActionMapping actionMapping,
                                       ActionForm actionForm,
                                       HttpServletRequest httpServletRequest,
                                       String criterionIdStr)
            throws Exception {

        Criterion criterion = service.getCriterionById(Long.parseLong(criterionIdStr));

        CriterionForm form = (CriterionForm) actionForm;
        form.initializFormFromDomainObject(criterion);

        return actionMapping.findForward(Constants.FORWARD_SUCCESS);
    }

}
