package org.mmc.web.actions.administration;

import org.mmc.web.actions.BaseSecurityAction;
import org.mmc.web.Constants;
import org.mmc.web.forms.administration.DiseaseForm;
import org.mmc.model.service.DiseasesService;
import org.mmc.model.domain.Disease;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForm;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Created on: 2007-9-9
 *
 * @author Stoyo Venkov
 */
public class EditDiseaseAction extends BaseSecurityAction {
    private DiseasesService service;

    public EditDiseaseAction(DiseasesService service) {
        this.service = service;
    }

    protected ActionForward doExecute(ActionMapping actionMapping,
                                      ActionForm actionForm,
                                      HttpServletRequest httpServletRequest,
                                      HttpServletResponse httpServletResponse)
            throws Exception {

        ActionForward result = null;
        String diseaseIdStr = httpServletRequest.getParameter("diseaseId");
        if(diseaseIdStr != null) {
            result = loadDisease(actionMapping, actionForm, httpServletRequest, diseaseIdStr);
        } else {
            result = loadNew(actionMapping, actionForm, httpServletRequest);
        }

        return result;
    }

    private ActionForward loadNew(ActionMapping actionMapping,
                                  ActionForm actionForm,
                                  HttpServletRequest httpServletRequest)
            throws Exception {

        return actionMapping.findForward(Constants.FORWARD_SUCCESS);
    }

    private ActionForward loadDisease(ActionMapping actionMapping,
                                      ActionForm actionForm,
                                      HttpServletRequest httpServletRequest,
                                      String diseaseIdStr)
            throws Exception {

        Disease disease = service.getDiseaseById(Long.parseLong(diseaseIdStr));

        DiseaseForm form = (DiseaseForm) actionForm;
        form.initializFormFromDomainObject(disease);

        return actionMapping.findForward(Constants.FORWARD_SUCCESS);
    }
}
