package org.mmc.web.actions.administration;

import org.mmc.web.actions.BaseSecurityAction;
import org.mmc.web.Constants;
import org.mmc.web.forms.administration.EthnicGroupForm;
import org.mmc.model.service.EthnicGroupsService;
import org.mmc.model.domain.EthnicGroup;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForm;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Created on: 2007-9-17
 *
 * @author Stoyo Venkov
 */
public class EditEthnicGroupAction extends BaseSecurityAction {
    private EthnicGroupsService service;

    public EditEthnicGroupAction(EthnicGroupsService service) {
        this.service = service;
    }

    protected ActionForward doExecute(ActionMapping actionMapping,
                                      ActionForm actionForm,
                                      HttpServletRequest httpServletRequest,
                                      HttpServletResponse httpServletResponse)
            throws Exception {

        ActionForward result = null;
        String groupIdStr = httpServletRequest.getParameter("groupId");
        if(groupIdStr != null) {
            result = loadExisting(actionMapping, actionForm, httpServletRequest, groupIdStr);
        } else {
            result = loadNew(actionMapping, actionForm, httpServletRequest);
        }

        return result;
    }

    private ActionForward loadNew(ActionMapping actionMapping,
                                  ActionForm actionForm,
                                  HttpServletRequest httpServletRequest)
            throws Exception {

        return actionMapping.findForward(Constants.FORWARD_SUCCESS);
    }

    private ActionForward loadExisting(ActionMapping actionMapping,
                                       ActionForm actionForm,
                                       HttpServletRequest httpServletRequest,
                                       String groupIdStr)
            throws Exception {

        EthnicGroup group = service.getEthnicGroupById(Long.parseLong(groupIdStr));

        EthnicGroupForm form = (EthnicGroupForm) actionForm;
        form.initializFormFromDomainObject(group);

        return actionMapping.findForward(Constants.FORWARD_SUCCESS);
    }

}
