package org.mmc.web.actions.administration;

import org.mmc.web.actions.BaseSecurityAction;
import org.mmc.web.Constants;
import org.mmc.web.forms.administration.PositionForm;
import org.mmc.model.service.MMCPositionsService;
import org.mmc.model.domain.MMCPosition;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForm;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Created on: 2007-9-16
 *
 * @author Stoyo Venkov
 */
public class EditPositionAction extends BaseSecurityAction {
    private MMCPositionsService service;

    public EditPositionAction(MMCPositionsService service) {
        this.service = service;
    }

    protected ActionForward doExecute(ActionMapping actionMapping,
                                      ActionForm actionForm,
                                      HttpServletRequest httpServletRequest,
                                      HttpServletResponse httpServletResponse)
            throws Exception {

        ActionForward result = null;
        String positionIdStr = httpServletRequest.getParameter("positionId");
        if(positionIdStr != null) {
            result = loadExisting(actionMapping, actionForm, httpServletRequest, positionIdStr);
        } else {
            result = loadNew(actionMapping, actionForm, httpServletRequest);
        }

        return result;
    }

    private ActionForward loadNew(ActionMapping actionMapping,
                                  ActionForm actionForm,
                                  HttpServletRequest httpServletRequest)
            throws Exception {

        return actionMapping.findForward(Constants.FORWARD_SUCCESS);
    }

    private ActionForward loadExisting(ActionMapping actionMapping,
                                       ActionForm actionForm,
                                       HttpServletRequest httpServletRequest,
                                       String positionIdStr)
            throws Exception {

        MMCPosition position = service.getPositionById(Long.parseLong(positionIdStr));

        PositionForm form = (PositionForm) actionForm;
        form.initializFormFromDomainObject(position);

        return actionMapping.findForward(Constants.FORWARD_SUCCESS);
    }
}
