package org.mmc.web.actions.administration;

import org.mmc.web.actions.BaseSecurityAction;
import org.mmc.web.Constants;
import org.mmc.web.forms.administration.ProbeTypeForm;
import org.mmc.model.service.ProbeTypesService;
import org.mmc.model.domain.ProbeType;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForm;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Created on: 2007-9-20
 *
 * @author Stoyo Venkov
 */
public class EditProbeTypeAction extends BaseSecurityAction {
    private ProbeTypesService service;

    public EditProbeTypeAction(ProbeTypesService service) {
        this.service = service;
    }

    protected ActionForward doExecute(ActionMapping actionMapping,
                                      ActionForm actionForm,
                                      HttpServletRequest httpServletRequest,
                                      HttpServletResponse httpServletResponse)
            throws Exception {

        ActionForward result = null;
        String typeIdStr = httpServletRequest.getParameter("typeId");
        if(typeIdStr != null) {
            result = loadExisting(actionMapping, actionForm, httpServletRequest, typeIdStr);
        } else {
            result = loadNew(actionMapping, actionForm, httpServletRequest);
        }

        return result;
    }

    private ActionForward loadNew(ActionMapping actionMapping,
                                  ActionForm actionForm,
                                  HttpServletRequest httpServletRequest)
            throws Exception {

        return actionMapping.findForward(Constants.FORWARD_SUCCESS);
    }

    private ActionForward loadExisting(ActionMapping actionMapping,
                                       ActionForm actionForm,
                                       HttpServletRequest httpServletRequest,
                                       String typeIdStr)
            throws Exception {

        ProbeType type = service.getProbeTypeById(Long.parseLong(typeIdStr));

        ProbeTypeForm form = (ProbeTypeForm) actionForm;
        form.initializFormFromDomainObject(type);

        return actionMapping.findForward(Constants.FORWARD_SUCCESS);
    }

}
