package org.mmc.web.actions.administration;

import org.mmc.web.Constants;
import org.mmc.web.forms.administration.EditProjectForm;
import org.mmc.model.service.ProjectsService;
import org.mmc.model.service.DiseasesService;
import org.mmc.model.domain.Project;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForm;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Created on: 2007-9-20
 *
 * @author Stoyo Venkov
 */
public class EditProjectAction extends BaseProjectAction {

    public EditProjectAction(ProjectsService service, DiseasesService diseasesService) {
        super(service, diseasesService);
    }

    protected ActionForward doExecute(ActionMapping actionMapping,
                                      ActionForm actionForm,
                                      HttpServletRequest httpServletRequest,
                                      HttpServletResponse httpServletResponse)
            throws Exception {

        ActionForward result = null;
        String idStr = httpServletRequest.getParameter("projectId");
        if(idStr != null) {
            result = loadExisting(actionMapping, actionForm, httpServletRequest, idStr);
        } else {
            result = loadNew(actionMapping, actionForm, httpServletRequest);
        }

        return result;
    }

    private ActionForward loadNew(ActionMapping actionMapping,
                                  ActionForm actionForm,
                                  HttpServletRequest httpServletRequest)
            throws Exception {

        EditProjectForm form = (EditProjectForm) actionForm;
        setUpDiseases(form);

        return actionMapping.findForward(Constants.FORWARD_SUCCESS);
    }

    private ActionForward loadExisting(ActionMapping actionMapping,
                                       ActionForm actionForm,
                                       HttpServletRequest httpServletRequest,
                                       String positionIdStr)
            throws Exception {

        Project project = service.getProjectById(Long.parseLong(positionIdStr));

        EditProjectForm form = (EditProjectForm) actionForm;
        form.initializFormFromDomainObject(project);
        setUpDiseases(form);

        return actionMapping.findForward(Constants.FORWARD_SUCCESS);
    }
}
