package org.mmc.web.actions.administration;

import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForm;
import org.mmc.web.Constants;
import org.mmc.web.forms.administration.EditUserForm;
import org.mmc.model.service.UsersService;
import org.mmc.model.domain.User;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;

/**
 * Created on: 2007-9-18
 *
 * @author Stoyo Venkov
 */
public class EditUserAction extends BaseUserAction {

    public EditUserAction(UsersService service) {
        super(service);
    }

    protected ActionForward doExecute(ActionMapping actionMapping,
                                      ActionForm actionForm,
                                      HttpServletRequest httpServletRequest,
                                      HttpServletResponse httpServletResponse)
            throws Exception {

        ActionForward result = null;
        String positionIdStr = httpServletRequest.getParameter("userId");
        if(positionIdStr != null) {
            result = loadExisting(actionMapping, actionForm, httpServletRequest, positionIdStr);
        } else {
            result = loadNew(actionMapping, actionForm, httpServletRequest);
        }

        return result;
    }

    private ActionForward loadNew(ActionMapping actionMapping,
                                  ActionForm actionForm,
                                  HttpServletRequest httpServletRequest)
            throws Exception {

        EditUserForm form = (EditUserForm) actionForm;
        setUpRoles(form);
        setUpPoisitions(form);

        return actionMapping.findForward(Constants.FORWARD_SUCCESS);
    }

    private ActionForward loadExisting(ActionMapping actionMapping,
                                       ActionForm actionForm,
                                       HttpServletRequest httpServletRequest,
                                       String positionIdStr)
            throws Exception {

        User user = service.getUserById(Long.parseLong(positionIdStr));

        EditUserForm form = (EditUserForm) actionForm;
        form.initializFormFromDomainObject(user);
        setUpRoles(form);
        setUpPoisitions(form);

        return actionMapping.findForward(Constants.FORWARD_SUCCESS);
    }
}
