package org.mmc.web.actions.administration;

import org.mmc.web.actions.BaseSecurityAction;
import org.mmc.web.Constants;
import org.mmc.web.forms.administration.CriterionForm;
import org.mmc.model.service.CriteriaService;
import org.mmc.model.domain.Criterion;
import org.apache.struts.action.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Created on: 2007-9-20
 *
 * @author Stoyo Venkov
 */
public class SaveCriterionAction extends BaseSecurityAction {
    private CriteriaService service;

    public SaveCriterionAction(CriteriaService service) {
        this.service = service;
    }

    protected ActionForward doExecute(ActionMapping actionMapping,
                                      ActionForm actionForm,
                                      HttpServletRequest httpServletRequest,
                                      HttpServletResponse httpServletResponse)
            throws Exception {

        CriterionForm form = (CriterionForm) actionForm;

        ActionErrors errors = form.validate(actionMapping, httpServletRequest);
        if(!errors.isEmpty()) {
            saveErrors(httpServletRequest, (ActionMessages) errors);
        } else {
            Criterion criterion = form.createDomainObject();
            criterion = service.saveOrUpdateCriterion(criterion);
            form.initializFormFromDomainObject(criterion);

            ActionMessages messages = new ActionMessages();
            messages.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("message.criterionSaved"));
            saveMessages(httpServletRequest, messages);
        }
        return actionMapping.findForward(Constants.FORWARD_SUCCESS);
    }

}
