package org.mmc.web.actions.administration;

import org.mmc.web.actions.BaseSecurityAction;
import org.mmc.web.Constants;
import org.mmc.web.actions.BaseSecurityAction;
import org.mmc.web.forms.administration.DiseaseForm;
import org.mmc.model.service.DiseasesService;
import org.mmc.model.domain.Disease;
import org.apache.struts.action.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Created on: 2007-9-9
 *
 * @author Stoyo Venkov
 */
public class SaveDiseaseAction extends BaseSecurityAction {
    private DiseasesService service;

    public SaveDiseaseAction(DiseasesService service) {
        this.service = service;
    }

    protected ActionForward doExecute(ActionMapping actionMapping,
                                      ActionForm actionForm,
                                      HttpServletRequest httpServletRequest,
                                      HttpServletResponse httpServletResponse)
            throws Exception {

        DiseaseForm form = (DiseaseForm) actionForm;

        ActionErrors errors = form.validate(actionMapping, httpServletRequest);
        if(!errors.isEmpty()) {
            saveErrors(httpServletRequest, (ActionMessages) errors);
        } else {
            Disease disease = form.createDomainObject();
            disease = service.saveOrUpdateDisease(disease);
            form.initializFormFromDomainObject(disease);

            ActionMessages messages = new ActionMessages();
            messages.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("message.diseaseSaved"));
            saveMessages(httpServletRequest, messages);
        }
        return actionMapping.findForward(Constants.FORWARD_SUCCESS);
    }
}
