package org.mmc.web.actions.administration;

import org.mmc.web.actions.BaseSecurityAction;
import org.mmc.web.Constants;
import org.mmc.web.forms.administration.EthnicGroupForm;
import org.mmc.model.service.EthnicGroupsService;
import org.mmc.model.domain.EthnicGroup;
import org.apache.struts.action.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Created on: 2007-9-17
 *
 * @author Stoyo Venkov
 */
public class SaveEthnicGroupAction extends BaseSecurityAction {
    private EthnicGroupsService service;

    public SaveEthnicGroupAction(EthnicGroupsService service) {
        this.service = service;
    }

    protected ActionForward doExecute(ActionMapping actionMapping,
                                      ActionForm actionForm,
                                      HttpServletRequest httpServletRequest,
                                      HttpServletResponse httpServletResponse)
            throws Exception {

        EthnicGroupForm form = (EthnicGroupForm) actionForm;

        ActionErrors errors = form.validate(actionMapping, httpServletRequest);
        if(!errors.isEmpty()) {
            saveErrors(httpServletRequest, (ActionMessages) errors);
        } else {
            EthnicGroup group = form.createDomainObject();
            group = service.saveOrUpdateEthnicGroup(group);
            form.initializFormFromDomainObject(group);

            ActionMessages messages = new ActionMessages();
            messages.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("message.groupSaved"));
            saveMessages(httpServletRequest, messages);
        }
        return actionMapping.findForward(Constants.FORWARD_SUCCESS);
    }

}
