package org.mmc.web.actions.administration;

import org.mmc.web.actions.BaseSecurityAction;
import org.mmc.web.Constants;
import org.mmc.web.forms.administration.PositionForm;
import org.mmc.model.service.MMCPositionsService;
import org.mmc.model.domain.MMCPosition;
import org.apache.struts.action.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Created on: 2007-9-16
 *
 * @author Stoyo Venkov
 */
public class SavePositionAction  extends BaseSecurityAction {
    private MMCPositionsService service;

    public SavePositionAction(MMCPositionsService service) {
        this.service = service;
    }

    protected ActionForward doExecute(ActionMapping actionMapping,
                                      ActionForm actionForm,
                                      HttpServletRequest httpServletRequest,
                                      HttpServletResponse httpServletResponse)
            throws Exception {

        PositionForm form = (PositionForm) actionForm;

        ActionErrors errors = form.validate(actionMapping, httpServletRequest);
        if(!errors.isEmpty()) {
            saveErrors(httpServletRequest, (ActionMessages) errors);
        } else {
            MMCPosition position = form.createDomainObject();
            position = service.saveOrUpdatePosition(position);
            form.initializFormFromDomainObject(position);

            ActionMessages messages = new ActionMessages();
            messages.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("message.positionSaved"));
            saveMessages(httpServletRequest, messages);
        }
        return actionMapping.findForward(Constants.FORWARD_SUCCESS);
    }
}
