package org.mmc.web.actions.administration;

import org.mmc.web.actions.BaseSecurityAction;
import org.mmc.web.Constants;
import org.mmc.web.forms.administration.ProbeTypeForm;
import org.mmc.model.domain.ProbeType;
import org.mmc.model.service.ProbeTypesService;
import org.apache.struts.action.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Created on: 2007-9-20
 *
 * @author Stoyo Venkov
 */
public class SaveProbeTypeAction  extends BaseSecurityAction {
    private ProbeTypesService service;

    public SaveProbeTypeAction(ProbeTypesService service) {
        this.service = service;
    }

    protected ActionForward doExecute(ActionMapping actionMapping,
                                      ActionForm actionForm,
                                      HttpServletRequest httpServletRequest,
                                      HttpServletResponse httpServletResponse)
            throws Exception {

        ProbeTypeForm form = (ProbeTypeForm) actionForm;

        ActionErrors errors = form.validate(actionMapping, httpServletRequest);
        if(!errors.isEmpty()) {
            saveErrors(httpServletRequest, (ActionMessages) errors);
        } else {
            ProbeType type = form.createDomainObject();
            type = service.saveOrUpdateProbeType(type);
            form.initializFormFromDomainObject(type);

            ActionMessages messages = new ActionMessages();
            messages.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("message.probeTypeSaved"));
            saveMessages(httpServletRequest, messages);
        }
        return actionMapping.findForward(Constants.FORWARD_SUCCESS);
    }

}
