package org.mmc.web.actions.administration;

import org.apache.struts.action.*;
import org.mmc.web.Constants;
import org.mmc.web.forms.administration.EditProjectForm;
import org.mmc.utils.ParseUtils;
import org.mmc.utils.StringUtils;
import org.mmc.model.service.ProjectsService;
import org.mmc.model.service.DiseasesService;
import org.mmc.model.domain.Project;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Created on: 2007-9-20
 *
 * @author Stoyo Venkov
 */
public class SaveProjectAction extends BaseProjectAction {

    public SaveProjectAction(ProjectsService service, DiseasesService diseasesService) {
        super(service, diseasesService);
    }

    protected ActionForward doExecute(ActionMapping actionMapping,
                                      ActionForm actionForm,
                                      HttpServletRequest httpServletRequest,
                                      HttpServletResponse httpServletResponse)
            throws Exception {

        EditProjectForm form = (EditProjectForm) actionForm;

        ActionErrors errors = form.validate(actionMapping, httpServletRequest);
        if(!errors.isEmpty()) {
            saveErrors(httpServletRequest, (ActionMessages) errors);
        } else {
            Project project = createDomainObject(form);
            project = service.saveOrUpdateProject(project);
            form.initializFormFromDomainObject(project);

            ActionMessages messages = new ActionMessages();
            messages.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("message.projectSaved"));
            saveMessages(httpServletRequest, messages);
        }
        setUpDiseases(form);
        return actionMapping.findForward(Constants.FORWARD_SUCCESS);
    }

    private Project createDomainObject(EditProjectForm form) {
        Project result = new Project();
        result.setId(ParseUtils.parseLong(form.getId()));
        result.setName(ParseUtils.parseString(form.getName()));
        result.setCode(ParseUtils.parseString(form.getCode()));

        result.setActive(ParseUtils.convertToBooleanNoNull(form.getActive()));
        result.setVersion(ParseUtils.parseLong(form.getVersion()));

        result.setDiseases(getChosen(form.getDiseaseIds(), diseaseService.getAllActive()));

        return result;
    }
}
