package org.mmc.web.actions.administration;

import org.mmc.model.service.ConfParamsService;
import org.mmc.model.domain.ConfParam;
import org.mmc.web.forms.administration.TermsParamsForm;
import org.mmc.web.Constants;
import org.mmc.web.actions.BaseSecurityAction;
import org.apache.struts.action.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Created on: 2007-10-20
 *
 * @author Stoyo Venkov
 */
public class SaveTermsParamsAction extends BaseSecurityAction {
    private ConfParamsService service;

    public SaveTermsParamsAction(ConfParamsService service) {
        this.service = service;
    }

    protected ActionForward doExecute(ActionMapping actionMapping,
                                      ActionForm actionForm,
                                      HttpServletRequest httpServletRequest,
                                      HttpServletResponse httpServletResponse)
            throws Exception {

        TermsParamsForm form = (TermsParamsForm) actionForm;

        ActionErrors errors = form.validate(actionMapping, httpServletRequest);
        if(!errors.isEmpty()) {
            saveErrors(httpServletRequest, (ActionMessages) errors);
        } else {
            service.updateParam(ConfParam.ALARM_TERM_PARAM, form.getValue());
            ActionMessages messages = new ActionMessages();
            messages.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("message.paramsSaved"));
            saveMessages(httpServletRequest, messages);
        }

        return actionMapping.findForward(Constants.FORWARD_SUCCESS);
    }
}
