package org.mmc.web.actions.probes;

import org.mmc.web.actions.BaseSecurityAction;
import org.mmc.web.forms.probes.RegisterProbeForm;
import org.mmc.model.service.NomenclaturesService;
import org.mmc.model.domain.Project;
import org.mmc.model.domain.HasId;

import java.util.List;
import java.util.ArrayList;

/**
 * Created on: 2007-10-10
 *
 * @author Stoyo Venkov
 */
public abstract class BaseProbeAction extends BaseSecurityAction {
    protected NomenclaturesService nomenclaturesService;

    public BaseProbeAction(NomenclaturesService nomenclaturesService) {
        this.nomenclaturesService = nomenclaturesService;
    }

    protected void loadProbeTypes(RegisterProbeForm form) {
        form.setProbeTypesList(nomenclaturesService.getProbeTypesService().getAllActive());
    }

    protected void loadCriteria(RegisterProbeForm form) {
        List allCriteria = nomenclaturesService.getCriteriaService().getAllCriteria();
        form.setCriteriaList(getChosenList(form.getChosenCriteria(), allCriteria));
        form.setAvailableCriteriaList(getAvailableList(form.getChosenCriteria(), allCriteria));
    }

    protected void loadProjects(RegisterProbeForm form) {
        List allProjects = nomenclaturesService.getProjectsService().getAllActive();
        form.setProjectsList(getChosenList(form.getChosenProjects(), allProjects));
        form.setAvailableProjectsList(getAvailableList(form.getChosenProjects(), allProjects));
    }

    protected List getChosenList(String[] chosenIds, List all) {
        List chosenList = new ArrayList();
        if (chosenIds == null) {
            return chosenList;
        }

        HasId objectWithId = null;
        String strId;
        String chosenId;

        for (int i = 0; i < all.size(); i++) {
            objectWithId = (HasId) all.get(i);

            for (int j = 0; j < chosenIds.length; j++) {
                strId = objectWithId.getId().toString();
                chosenId = chosenIds[j];

                if (chosenId.equals(strId)) {
                    chosenList.add(objectWithId);
                }
            }
        }

        return chosenList;

    }

    protected List getAvailableList(String[] chosenIds, List all){
        if (chosenIds == null) {
            return new ArrayList(all);
        }

        List result = new ArrayList();

        for(int i = 0; i < all.size(); i++) {
            HasId objectWithId = (HasId) all.get(i);
            int j;
            for(j = 0; j < chosenIds.length; j++) {
                String strId = chosenIds[j];
                if(objectWithId.getId().equals(new Long(strId))) {
                    break;
                }
            }
            if(j == chosenIds.length) {
                result.add(objectWithId);
            }
        }

        return result;
    }
}
