package org.mmc.web.actions.probes;

import org.mmc.web.forms.probes.RegisterStepForm;
import org.mmc.model.service.ProbesService;
import org.mmc.model.domain.Probe;
import org.mmc.model.domain.ProbeProject;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.ArrayList;

/**
 * Created on: 2007-10-13
 *
 * @author Stoyo Venkov
 */
public abstract class BaseStepAction extends ProbeAwareAction {
    protected ProbesService service;

    public BaseStepAction(ProbesService service) {
        this.service = service;
    }

    protected void loadProjects(HttpServletRequest request, RegisterStepForm form) {
        Probe probe = getSessionProbe(request);
        List probeProjects = probe.getProbeProjects();
        List projects = new ArrayList();
        for (int i = 0; i < probeProjects.size(); i++) {
            ProbeProject probeProject = (ProbeProject) probeProjects.get(i);
            projects.add(probeProject.getProject());
        }
        form.setProjectsList(projects);
    }

    protected void loadSteps(RegisterStepForm form) {
        form.setNomStepsList(service.getNomenclaturesService().getStepsService().getAllProcessSteps());
    }
}
