package org.mmc.web.actions.probes;

import org.mmc.web.actions.search.BaseSearchAction;
import org.mmc.web.Constants;
import org.mmc.web.forms.probes.SearchProbeForm;
import org.mmc.model.filters.BasePageFilter;
import org.mmc.model.filters.ProbesFilter;
import org.mmc.model.service.NomenclaturesService;
import org.mmc.model.service.ProbesService;
import org.apache.struts.action.ActionForm;

import java.util.List;

/**
 * Created on: 2007-10-13
 *
 * @author Stoyo Venkov
 */
public class BrowseProbesAction extends BaseSearchAction {
    NomenclaturesService nomenclaturesSservice;
    ProbesService probesService;

    public BrowseProbesAction(ProbesService probesService, NomenclaturesService nomenclaturesSservice) {
        this.probesService = probesService;
        this.nomenclaturesSservice = nomenclaturesSservice;
    }

    protected BasePageFilter constructFilter() {
        ProbesFilter filter = new ProbesFilter(Constants.PAGE_SIZE);
        return filter;
    }

    protected void populateFilter(BasePageFilter filter, ActionForm actionForm) {
        SearchProbeForm form = (SearchProbeForm) actionForm;
        ProbesFilter result = (ProbesFilter) filter;
        form.initializeFilterObject(result);
    }

    protected void populateForm(ActionForm actionForm, BasePageFilter filter) {
        SearchProbeForm form = (SearchProbeForm) actionForm;
        ProbesFilter result = (ProbesFilter) filter;
        form.initializFormFromFilter(result);
        prePopulateForm(actionForm);
    }

    protected void prePopulateForm(ActionForm actionForm) {
        SearchProbeForm form = (SearchProbeForm) actionForm;
        form.setProjectsList(nomenclaturesSservice.getProjectsService().getAllProjects());
        form.setUsersList(nomenclaturesSservice.getUsersService().getAllUsers());
    }

    protected List exposeDbData(BasePageFilter filter) {
        return probesService.getProbesByFilter((ProbesFilter) filter);
    }

    protected String getFilterAttributeName() {
        return Constants.PROBES_FILTER_ATTR;
    }
}
