package org.mmc.web.actions.probes;

import org.mmc.web.actions.BaseSecurityAction;
import org.mmc.web.Constants;
import org.mmc.model.service.ProbesService;
import org.mmc.model.domain.Probe;
import org.mmc.utils.StringUtils;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForm;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Created on: 2007-10-13
 *
 * @author Stoyo Venkov
 */
public class ManageProbeAction extends ProbeAwareAction {
    private ProbesService probesService;

    public ManageProbeAction(ProbesService probesService) {
        this.probesService = probesService;
    }

    protected ActionForward doExecute(ActionMapping actionMapping,
                                      ActionForm actionForm,
                                      HttpServletRequest httpServletRequest,
                                      HttpServletResponse httpServletResponse)
            throws Exception {

        String operation = httpServletRequest.getParameter("operation");
        String probeIdStr = httpServletRequest.getParameter("probeId");
        Long probeId = new Long(probeIdStr);

        Probe probe = probesService.getProbeById(probeId);

        if("cancel".equalsIgnoreCase(operation)) {
            String reason = httpServletRequest.getParameter("reason");
            probesService.cancelProbe(probe, reason);
        } else if("complete".equalsIgnoreCase(operation)) {
            probesService.completeProbe(probe);
        } else if("markSent".equalsIgnoreCase(operation)) {
            probesService.markProbeAsSent(probe);
        }

        setSessionProbe(httpServletRequest, probe);

        return actionMapping.findForward(Constants.FORWARD_SUCCESS);
    }
}
