package org.mmc.web.actions.probes;

import org.apache.struts.action.*;
import org.mmc.web.Constants;
import org.mmc.web.forms.probes.RegisterMovementForm;
import org.mmc.model.service.ProbesService;
import org.mmc.utils.ParseUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Created on: 2007-10-13
 *
 * @author Stoyo Venkov
 */
public class RegisterMovementAction extends ProbeAwareAction {
    private ProbesService service;

    public RegisterMovementAction(ProbesService service) {
        this.service = service;
    }

    protected ActionForward doExecute(ActionMapping actionMapping,
                                      ActionForm actionForm,
                                      HttpServletRequest httpServletRequest,
                                      HttpServletResponse httpServletResponse)
            throws Exception {

        RegisterMovementForm form = (RegisterMovementForm) actionForm;

        ActionErrors errors = form.validate(actionMapping, httpServletRequest);
        if(!errors.isEmpty()) {
            saveErrors(httpServletRequest, (ActionMessages) errors);
            return actionMapping.findForward(Constants.FORWARD_ERROR);
        } else {
            Long probeId = getSessionProbe(httpServletRequest).getId();
            Long prevLocationId = ParseUtils.parseLong(form.getPrevLocationId());
            Long stepId = ParseUtils.parseLong(form.getStepId());
            Long tubeId = ParseUtils.parseLong(form.getTubeId());
            Long rackId = ParseUtils.parseLong(form.getRackId());
            Long plateId = ParseUtils.parseLong(form.getPlateId());
            Long batchGroupId = ParseUtils.parseLong(form.getBatchGroupId());
            String coordinates = ParseUtils.parseString(form.getCoordinates());

            service.registerLocation(probeId, stepId, prevLocationId, tubeId, rackId, plateId, batchGroupId, coordinates);

            httpServletRequest.setAttribute("currStepId", form.getStepId());
            return actionMapping.findForward(Constants.FORWARD_SUCCESS);
        }
    }
}
