package org.mmc.web.actions.probes;

import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForm;
import org.mmc.web.forms.probes.RegisterStepForm;
import org.mmc.web.Constants;
import org.mmc.model.service.ProbesService;
import org.mmc.model.domain.Step;
import org.mmc.model.domain.User;
import org.mmc.model.domain.Probe;
import org.mmc.utils.ParseUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Date;

/**
 * Created on: 2007-10-13
 *
 * @author Stoyo Venkov
 */
public class RegisterStepAction extends BaseStepAction {
    public RegisterStepAction(ProbesService service) {
        super(service);
    }

    protected ActionForward doExecute(ActionMapping actionMapping,
                                      ActionForm actionForm,
                                      HttpServletRequest httpServletRequest,
                                      HttpServletResponse httpServletResponse)
            throws Exception {

        RegisterStepForm form = (RegisterStepForm) actionForm;

        User user = getLoggedUser(httpServletRequest);
        Probe probe = getSessionProbe(httpServletRequest);

        Long projectId = ParseUtils.parseLong(form.getProjectId());
        Long prevStepId = ParseUtils.parseLong(form.getPrevStepId());
        Long kindId = ParseUtils.parseLong(form.getKindId());
        String notes = ParseUtils.parseString(form.getNotes());

        service.registerStep(user.getId(), prevStepId, probe.getId(), projectId, kindId, notes);

        return actionMapping.findForward(Constants.FORWARD_SUCCESS);
    }
}
