package org.mmc.web.actions.probes;

import org.mmc.web.actions.BaseSecurityAction;
import org.mmc.web.Constants;
import org.mmc.web.forms.probes.TubeForm;
import org.mmc.web.forms.probes.BatchGroupForm;
import org.mmc.model.domain.Tube;
import org.mmc.model.domain.ContainerObject;
import org.mmc.model.domain.BatchGroup;
import org.mmc.model.service.ContainerAndGroupsService;
import org.apache.struts.action.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Date;

/**
 * Created on: 2007-10-7
 *
 * @author Stoyo Venkov
 */
public class SaveBatchGroupAction extends BaseSecurityAction {
    private ContainerAndGroupsService service;

    public SaveBatchGroupAction(ContainerAndGroupsService service) {
        this.service = service;
    }

    protected ActionForward doExecute(ActionMapping actionMapping,
                                      ActionForm actionForm,
                                      HttpServletRequest httpServletRequest,
                                      HttpServletResponse httpServletResponse)
            throws Exception {

        BatchGroupForm form = (BatchGroupForm) actionForm;

        ActionErrors errors = form.validate(actionMapping, httpServletRequest);
        if(!errors.isEmpty()) {
            saveErrors(httpServletRequest, (ActionMessages) errors);
        } else {
            BatchGroup object = new BatchGroup();
            object.setRegistrationDate(new Date());
            object.setUser(getLoggedUser(httpServletRequest));
            object.setName(form.getName());
            object = service.saveOrUpdateBatchGroup(object);

            ActionMessages messages = new ActionMessages();
            messages.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("message.groupRegistered", object.getId()));
            saveMessages(httpServletRequest, messages);
        }

        return actionMapping.findForward(Constants.FORWARD_SUCCESS);
    }
}
