package org.mmc.web.actions.probes;

import org.mmc.web.actions.BaseSecurityAction;
import org.mmc.web.Constants;
import org.mmc.web.forms.probes.SimpleContainerForm;
import org.mmc.model.service.ContainerAndGroupsService;
import org.mmc.model.domain.Rack;
import org.apache.struts.action.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Date;

/**
 * Created on: 2007-10-7
 *
 * @author Stoyo Venkov
 */
public class SaveRackAction extends BaseSecurityAction {
    private ContainerAndGroupsService service;

    public SaveRackAction(ContainerAndGroupsService service) {
        this.service = service;
    }

    protected ActionForward doExecute(ActionMapping actionMapping,
                                      ActionForm actionForm,
                                      HttpServletRequest httpServletRequest,
                                      HttpServletResponse httpServletResponse)
            throws Exception {

        SimpleContainerForm form = (SimpleContainerForm) actionForm;

        ActionErrors errors = form.validate(actionMapping, httpServletRequest);
        if(!errors.isEmpty()) {
            saveErrors(httpServletRequest, (ActionMessages) errors);
        } else {
            Rack object = new Rack();
            object.setRegistrationDate(new Date());
            object.setUser(getLoggedUser(httpServletRequest));
            object.setLocation(form.getLocation());
            object = (Rack) service.saveOrUpdateContainer(object);

            ActionMessages messages = new ActionMessages();
            messages.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("message.rackRegistered", object.getId()));
            saveMessages(httpServletRequest, messages);
        }

        return actionMapping.findForward(Constants.FORWARD_SUCCESS);
    }
}
