package org.mmc.web.actions.probes;

import org.mmc.web.actions.BaseSecurityAction;
import org.mmc.web.Constants;
import org.mmc.web.forms.probes.TubeForm;
import org.mmc.model.domain.Tube;
import org.mmc.model.service.ContainerAndGroupsService;
import org.apache.struts.action.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Date;

/**
 * Created on: 2007-10-7
 *
 * @author Stoyo Venkov
 */
public class SaveTubeAction extends BaseSecurityAction {
    private ContainerAndGroupsService service;

    public SaveTubeAction(ContainerAndGroupsService service) {
        this.service = service;
    }

    protected ActionForward doExecute(ActionMapping actionMapping,
                                      ActionForm actionForm,
                                      HttpServletRequest httpServletRequest,
                                      HttpServletResponse httpServletResponse)
            throws Exception {

        TubeForm form = (TubeForm) actionForm;

        ActionErrors errors = form.validate(actionMapping, httpServletRequest);
        if(!errors.isEmpty()) {
            saveErrors(httpServletRequest, (ActionMessages) errors);
        } else {
            Tube tube = new Tube();
            tube.setRegistrationDate(new Date());
            tube.setUser(getLoggedUser(httpServletRequest));
            tube.setCode(form.getCode());
            tube.setLocation(form.getLocation());
            tube = (Tube) service.saveOrUpdateContainer(tube);

            ActionMessages messages = new ActionMessages();
            messages.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage("message.tubeRegistered", tube.getId()));
            saveMessages(httpServletRequest, messages);
        }

        return actionMapping.findForward(Constants.FORWARD_SUCCESS);
    }
}
