package org.mmc.web.actions.reports;

import org.mmc.model.service.ProbesService;
import org.mmc.web.forms.reports.PressingProbesForm;
import org.mmc.web.actions.BaseSecurityAction;
import org.mmc.utils.ParseUtils;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionForm;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.OutputStream;

/**
 * Created on: 2007-10-20
 *
 * @author Stoyo Venkov
 */
public class ExecuteExpiredProbesReportAction extends BaseSecurityAction {
    private ProbesService probesService;

    public ExecuteExpiredProbesReportAction(ProbesService probesService) {
        this.probesService = probesService;
    }

    protected ActionForward doExecute(ActionMapping actionMapping,
                                      ActionForm actionForm,
                                      HttpServletRequest httpServletRequest,
                                      HttpServletResponse httpServletResponse)
            throws Exception {

        PressingProbesForm form = (PressingProbesForm) actionForm;

        Long creatorId = ParseUtils.parseLong(form.getUserId());
        Long projectId = ParseUtils.parseLong(form.getProjectId());

        byte[] pdf = probesService.executeExpiredReport(creatorId, projectId);

        httpServletResponse.setContentType("application/pdf");

        OutputStream out = httpServletResponse.getOutputStream();

        out.write(pdf);
        out.flush();

        return null;
    }
}
