package org.mmc.web.actions.reports;

import org.mmc.web.actions.BaseSecurityAction;
import org.mmc.web.forms.reports.PatientReportForm;
import org.mmc.web.Constants;
import org.mmc.model.service.ProbesService;
import org.mmc.utils.ParseUtils;
import org.apache.struts.action.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.OutputStream;
import java.util.Date;

/**
 * Created on: 2007-10-20
 *
 * @author Stoyo Venkov
 */
public class ExecutePatientProbesReportAction extends BaseSecurityAction {
    private ProbesService probesService;

    public ExecutePatientProbesReportAction(ProbesService probesService) {
        this.probesService = probesService;
    }

    protected ActionForward doExecute(ActionMapping actionMapping,
                                      ActionForm actionForm,
                                      HttpServletRequest httpServletRequest,
                                      HttpServletResponse httpServletResponse)
            throws Exception {

        PatientReportForm form = (PatientReportForm) actionForm;

        ActionErrors errors = form.validate(actionMapping, httpServletRequest);
        if(!errors.isEmpty()) {
            saveErrors(httpServletRequest, (ActionMessages) errors);
            return actionMapping.findForward(Constants.FORWARD_SUCCESS);
        } else {
            Long patientId = ParseUtils.parseLong(form.getPatientId());
            Date regToDate = ParseUtils.parseDate(form.getRegToDate());

            byte[] pdf = probesService.executePatientReport(patientId, regToDate);

            httpServletResponse.setContentType("application/pdf");

            OutputStream out = httpServletResponse.getOutputStream();

            out.write(pdf);
            out.flush();

            return null;
        }
    }
}
