package org.mmc.web.actions.reports;

import org.mmc.web.actions.BaseSecurityAction;
import org.mmc.web.Constants;
import org.mmc.web.forms.reports.ProjectReportForm;
import org.mmc.model.service.ProbesService;
import org.mmc.utils.ParseUtils;
import org.apache.struts.action.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Date;
import java.io.OutputStream;

/**
 * Created on: 2007-10-20
 *
 * @author Stoyo Venkov
 */
public class ExecuteProjectProbesReportAction extends BaseSecurityAction {
    private ProbesService probesService;

    public ExecuteProjectProbesReportAction(ProbesService probesService) {
        this.probesService = probesService;
    }

    protected ActionForward doExecute(ActionMapping actionMapping,
                                      ActionForm actionForm,
                                      HttpServletRequest httpServletRequest,
                                      HttpServletResponse httpServletResponse)
            throws Exception {

        ProjectReportForm form = (ProjectReportForm) actionForm;

        ActionErrors errors = form.validate(actionMapping, httpServletRequest);
        if(!errors.isEmpty()) {
            saveErrors(httpServletRequest, (ActionMessages) errors);
            form.setProjectsList(probesService.getNomenclaturesService().getProjectsService().getAllProjects());
            return actionMapping.findForward(Constants.FORWARD_SUCCESS);
        } else {
            Long projectId = ParseUtils.parseLong(form.getProjectId());
            Date regFromDate = ParseUtils.parseDate(form.getRegFromDate());
            Date regToDate = ParseUtils.parseDate(form.getRegToDate());

            byte[] pdf = probesService.executeProjectReport(projectId, regFromDate, regToDate);

            httpServletResponse.setContentType("application/pdf");

            OutputStream out = httpServletResponse.getOutputStream();

            out.write(pdf);
            out.flush();

            return null;
        }
    }
}
