package org.mmc.web.actions.requests;

import org.mmc.web.actions.search.BaseSearchAction;
import org.mmc.web.Constants;
import org.mmc.web.forms.requests.SearchPatientForm;
import org.mmc.model.filters.BasePageFilter;
import org.mmc.model.filters.PatientsFilter;
import org.mmc.model.service.NomenclaturesService;
import org.mmc.model.service.PatientsService;
import org.apache.struts.action.ActionForm;

import java.util.List;

/**
 * Created on: 2007-10-7
 *
 * @author Stoyo Venkov
 */
public class ChoosePatientAction extends BaseSearchAction {
    NomenclaturesService nomenclaturesSservice;
    PatientsService patientsService;

    public ChoosePatientAction(PatientsService patientsService, NomenclaturesService nomenclaturesSservice) {
        this.patientsService = patientsService;
        this.nomenclaturesSservice = nomenclaturesSservice;
    }

    protected BasePageFilter constructFilter() {
        PatientsFilter filter = new PatientsFilter(Constants.PAGE_SIZE);
        return filter;
    }

    protected void populateFilter(BasePageFilter filter, ActionForm actionForm) {
        SearchPatientForm form = (SearchPatientForm) actionForm;
        PatientsFilter result = (PatientsFilter) filter;
        form.initializeFilterObject(result);
    }

    protected void populateForm(ActionForm actionForm, BasePageFilter filter) {
        SearchPatientForm form = (SearchPatientForm) actionForm;
        PatientsFilter result = (PatientsFilter) filter;
        form.initializFormFromFilter(result);
        prePopulateForm(actionForm);
    }

    protected void prePopulateForm(ActionForm actionForm) {
        SearchPatientForm form = (SearchPatientForm) actionForm;
        form.setProjectsList(nomenclaturesSservice.getProjectsService().getAllActive());
        form.setSexesList(nomenclaturesSservice.getSexesService().getAllSexes());
        form.setEthnicGroupsList(nomenclaturesSservice.getEthnicGroupsService().getAllEthnicGroups());
    }

    protected List exposeDbData(BasePageFilter filter) {
        return patientsService.getPatientsByFilter((PatientsFilter) filter);
    }
}
