package org.mmc.web.actions.requests;

import org.mmc.web.actions.search.BaseSearchAction;
import org.mmc.web.Constants;
import org.mmc.web.forms.requests.SearchRequestForm;
import org.mmc.model.filters.BasePageFilter;
import org.mmc.model.filters.RequestsFilter;
import org.mmc.model.service.AnalysisRequestsService;
import org.mmc.model.service.NomenclaturesService;
import org.apache.struts.action.ActionForm;

import java.util.List;

/**
 * Created on: 2007-10-9
 *
 * @author Stoyo Venkov
 */
public class ChooseRequestAction extends BaseSearchAction {
    private AnalysisRequestsService requestsService;
    private NomenclaturesService nomenclaturesService;

    public ChooseRequestAction(AnalysisRequestsService requestsService, NomenclaturesService nomenclaturesService) {
        this.requestsService = requestsService;
        this.nomenclaturesService = nomenclaturesService;
    }

    protected BasePageFilter constructFilter() {
        RequestsFilter filter = new RequestsFilter(Constants.PAGE_SIZE);
        return filter;
    }

    protected void populateFilter(BasePageFilter filter, ActionForm actionForm) {
        SearchRequestForm form = (SearchRequestForm) actionForm;
        RequestsFilter result = (RequestsFilter) filter;
        form.initializeFilterObject(result);
    }

    protected void populateForm(ActionForm actionForm, BasePageFilter filter) {
        SearchRequestForm form = (SearchRequestForm) actionForm;
        RequestsFilter result = (RequestsFilter) filter;
        form.initializFormFromFilter(result);
        form.setUsersList(nomenclaturesService.getUsersService().getAllUsers());
    }

    protected void prePopulateForm(ActionForm actionForm) {
        SearchRequestForm form = (SearchRequestForm) actionForm;
        form.setUsersList(nomenclaturesService.getUsersService().getAllUsers());
    }

    protected List exposeDbData(BasePageFilter filter) {
        return requestsService.getRequestsByFilter((RequestsFilter) filter);
    }

    protected String getFilterAttributeName() {
        return Constants.REQUESTS_FILTER_ATTR;
    }
}
