package org.mmc.web.filters;

import javax.servlet.*;
import java.io.IOException;

/**
 * Sets the encoding to UTF-8
 * 
 * @author <a href="mailto: ienev@vereo.bg">Stoyo Venkov</a>
 */
public class EncodingFilter implements Filter {
    private FilterConfig filterConfig;

    public void init(FilterConfig filterConfig) throws ServletException {
        this.filterConfig = filterConfig;
    }

    public void doFilter(ServletRequest servletRequest,
                         ServletResponse servletResponse,
                         FilterChain filterChain) throws IOException, ServletException {
        servletRequest.setCharacterEncoding("UTF-8");
        filterChain.doFilter(servletRequest, servletResponse);
    }

    public void destroy() {
        this.filterConfig = null;
    }
}
