package org.mmc.web.forms.administration;

import org.mmc.web.forms.BaseValidatorForm;
import org.mmc.utils.ParseUtils;
import org.mmc.model.domain.Criterion;
import org.mmc.model.filters.CriteriaFilter;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;

import javax.servlet.http.HttpServletRequest;

/**
 * Created on: 2007-9-20
 *
 * @author Stoyo Venkov
 */
public class CriterionForm extends BaseValidatorForm {
    private String id;
    private String name;
    private String code;
    private String active;
    private String version;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getActive() {
        return active;
    }

    public void setActive(String active) {
        this.active = active;
    }

    public String getVersion() {
        return version;
    }

    public void setVersion(String version) {
        this.version = version;
    }

    public Criterion createDomainObject() {
        Criterion result = new Criterion();
        result.setId(ParseUtils.parseLong(id));
        result.setName(name);
        result.setCode(code);
        result.setActive(ParseUtils.convertToBooleanNoNull(active));
        result.setVersion(ParseUtils.parseLong(version));
        return result;
    }

    public void initializeFilterObject(CriteriaFilter filter) {
        filter.setName(ParseUtils.parseString(name));
        filter.setActive(ParseUtils.convertToBoolean(active));
    }

    public void initializFormFromFilter(CriteriaFilter filter) {
        name = filter.getName();
        active = ParseUtils.convertToYNChar(filter.getActive());
    }

    public void initializFormFromDomainObject(Criterion criterion) {
        id = ParseUtils.convertLong(criterion.getId());
        name = criterion.getName();
        code = criterion.getCode();
        active = ParseUtils.convertToYNChar(criterion.getActive());
        version = ParseUtils.convertLong(criterion.getVersion());
    }

    public ActionErrors validate(ActionMapping actionMapping, HttpServletRequest httpServletRequest) {
        ActionErrors errors = new ActionErrors();

        checkRequiredStrField(errors, code, "label.code");
        checkRequiredStrField(errors, name, "label.nameLong");

        return errors;
    }
}
