package org.mmc.web.forms.administration;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;
import org.mmc.model.domain.Disease;
import org.mmc.model.filters.DiseasesFilter;
import org.mmc.utils.ParseUtils;
import org.mmc.web.forms.BaseValidatorForm;

import javax.servlet.http.HttpServletRequest;

/**
 * Created on: 2007-9-9
 *
 * @author Stoyo Venkov
 */
public class DiseaseForm extends BaseValidatorForm {
    private String id;
    private String name;
    private String code;
    private String active;
    private String version;

    public String getActive() {
        return active;
    }

    public void setActive(String active) {
        this.active = active;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getVersion() {
        return version;
    }

    public void setVersion(String version) {
        this.version = version;
    }

    public Disease createDomainObject() {
        Disease result = new Disease();
        result.setId(ParseUtils.parseLong(id));
        result.setName(name);
        result.setCode(code);
        result.setActive(ParseUtils.convertToBooleanNoNull(active));
        result.setVersion(ParseUtils.parseLong(version));
        return result;
    }

    public void modifyDomainObject(Disease disease) {
        disease.setName(ParseUtils.parseString(name));
        disease.setCode(ParseUtils.parseString(code));
        disease.setActive(ParseUtils.convertToBooleanNoNull(active));
    }

    public void initializeDomainObject(Disease disease) {
        disease.setName(ParseUtils.parseString(name));
        disease.setCode(ParseUtils.parseString(code));
        disease.setActive(ParseUtils.convertToBooleanNoNull(active));
    }

    public void initializeFilterObject(DiseasesFilter filter) {
        filter.setName(ParseUtils.parseString(name));
        filter.setCode(ParseUtils.parseString(code));
        filter.setActive(ParseUtils.convertToBoolean(active));
    }

    public void initializFormFromFilter(DiseasesFilter filter) {
        name = filter.getName();
        code = filter.getCode();
        active = ParseUtils.convertToYNChar(filter.getActive());
    }

    public void initializFormFromDomainObject(Disease disease) {
        id = ParseUtils.convertLong(disease.getId());
        name = disease.getName();
        code = disease.getCode();
        active = ParseUtils.convertToYNChar(disease.getActive());
        version = ParseUtils.convertLong(disease.getVersion());
    }

    public ActionErrors validate(ActionMapping actionMapping, HttpServletRequest httpServletRequest) {
        ActionErrors errors = new ActionErrors();

        checkRequiredStrField(errors, name, "label.nameLong");
        checkRequiredStrField(errors, code, "label.code");

        return errors;
    }
}
