package org.mmc.web.forms.administration;

import org.mmc.web.forms.BaseValidatorForm;
import org.mmc.utils.ParseUtils;
import org.mmc.model.domain.Project;
import org.mmc.model.domain.Disease;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * Created on: 2007-9-19
 *
 * @author Stoyo Venkov
 */
public class EditProjectForm extends BaseValidatorForm {
    private String id;
    private String name;
    private String code;
    private String active;
    private String version;

    private String[] diseaseIds;
    private List diseases;
    private String[] availableDiseaseIds;
    private List availableDiseases;

    public String getActive() {
        return active;
    }

    public void setActive(String active) {
        this.active = active;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getVersion() {
        return version;
    }

    public void setVersion(String version) {
        this.version = version;
    }

    public String[] getDiseaseIds() {
        return diseaseIds;
    }

    public void setDiseaseIds(String[] diseaseIds) {
        this.diseaseIds = diseaseIds;
    }

    public List getDiseases() {
        return diseases;
    }

    public void setDiseases(List diseases) {
        this.diseases = diseases;
    }

    public String[] getAvailableDiseaseIds() {
        return availableDiseaseIds;
    }

    public void setAvailableDiseaseIds(String[] availableDiseaseIds) {
        this.availableDiseaseIds = availableDiseaseIds;
    }

    public List getAvailableDiseases() {
        return availableDiseases;
    }

    public void setAvailableDiseases(List availableDiseases) {
        this.availableDiseases = availableDiseases;
    }

    public void initializFormFromDomainObject(Project project) {
        id = ParseUtils.convertLong(project.getId());
        name = project.getName();
        code = project.getCode();
        active = ParseUtils.convertToYNChar(project.getActive());
        version = ParseUtils.convertLong(project.getVersion());
        if(project.getDiseases() != null && project.getDiseases().size() > 0) {
            diseaseIds = new String[project.getDiseases().size()];
            for (int i = 0; i < project.getDiseases().size(); i++) {
                Disease disease = (Disease) project.getDiseases().get(i);
                diseaseIds[i] = disease.getId().toString();
            }
        }
    }

    public ActionErrors validate(ActionMapping actionMapping, HttpServletRequest httpServletRequest) {
        ActionErrors errors = new ActionErrors();

        checkRequiredStrField(errors, name, "label.nameLong");
        checkRequiredStrField(errors, code, "label.code");

        return errors;
    }

}
