package org.mmc.web.forms.administration;

import org.mmc.web.forms.BaseValidatorForm;
import org.mmc.utils.StringUtils;
import org.mmc.utils.ParseUtils;
import org.mmc.model.domain.User;
import org.mmc.model.domain.Role;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * Created on: 2007-9-17
 *
 * @author Stoyo Venkov
 */
public class EditUserForm extends BaseValidatorForm {
    private String id;
    private String firstName;
    private String secondName;
    private String familyName;
    private String email;
    private String phoneNumber;
    private String userName;
    private String password1;
    private String password2;
    private String positionId;
    private String version;
    private String active;

    private String[] availableRoles;
    private List availableRolesList;
    private String[] userRoles;
    private List userRolesList;

    private List positionsList;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getFirstName() {
        return firstName;
    }

    public void setFirstName(String firstName) {
        this.firstName = firstName;
    }

    public String getSecondName() {
        return secondName;
    }

    public void setSecondName(String secondName) {
        this.secondName = secondName;
    }

    public String getFamilyName() {
        return familyName;
    }

    public void setFamilyName(String familyName) {
        this.familyName = familyName;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getPhoneNumber() {
        return phoneNumber;
    }

    public void setPhoneNumber(String phoneNumber) {
        this.phoneNumber = phoneNumber;
    }

    public String getUserName() {
        return userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }

    public String getPassword1() {
        return password1;
    }

    public void setPassword1(String password1) {
        this.password1 = password1;
    }

    public String getPassword2() {
        return password2;
    }

    public void setPassword2(String password2) {
        this.password2 = password2;
    }

    public String getPositionId() {
        return positionId;
    }

    public void setPositionId(String positionId) {
        this.positionId = positionId;
    }

    public String getVersion() {
        return version;
    }

    public void setVersion(String version) {
        this.version = version;
    }

    public String getActive() {
        return active;
    }

    public void setActive(String active) {
        this.active = active;
    }

    public String[] getAvailableRoles() {
        return availableRoles;
    }

    public void setAvailableRoles(String[] availableRoles) {
        this.availableRoles = availableRoles;
    }

    public List getAvailableRolesList() {
        return availableRolesList;
    }

    public void setAvailableRolesList(List availableRolesList) {
        this.availableRolesList = availableRolesList;
    }

    public String[] getUserRoles() {
        return userRoles;
    }

    public void setUserRoles(String[] userRoles) {
        this.userRoles = userRoles;
    }

    public List getUserRolesList() {
        return userRolesList;
    }

    public void setUserRolesList(List userRolesList) {
        this.userRolesList = userRolesList;
    }

    public List getPositionsList() {
        return positionsList;
    }

    public void setPositionsList(List positionsList) {
        this.positionsList = positionsList;
    }

    public ActionErrors validate(ActionMapping actionMapping, HttpServletRequest httpServletRequest) {
        ActionErrors errors = new ActionErrors();

        checkRequiredStrField(errors, firstName, "label.name");
        checkRequiredStrField(errors, familyName, "label.familyName");
        checkRequiredStrField(errors, userName, "label.userName");
        checkRequiredStrField(errors, email, "label.email");
        checkRequiredStrField(errors, phoneNumber, "label.phoneNumber");
        checkRequiredStrField(errors, password1, "label.password1");
        checkRequiredStrField(errors, password2, "label.password2");
        checkRequiredStrField(errors, positionId, "label.position");

        if(!StringUtils.isEmpty(password1) && !StringUtils.isEmpty(password2) && !password1.equals(password2)) {
            addError(errors, "error.passwordsDontMatch");
        }

        if (userRoles == null || userRoles.length == 0) {
            addError(errors, "error.noRolesSelected");
        }


        return errors;
    }

    public void initializFormFromDomainObject(User user) {
        id = ParseUtils.convertLong(user.getId());
        firstName = ParseUtils.parseString(user.getFirstName());
        secondName = ParseUtils.parseString(user.getSecondName());
        familyName = ParseUtils.parseString(user.getFamilyName());

        if(user.getRoles() != null && user.getRoles().size() > 0) {
            userRoles = new String[user.getRoles().size()];
            for (int i = 0; i < user.getRoles().size(); i++) {
                Role role = (Role) user.getRoles().get(i);
                userRoles[i] = role.getId().toString();
            }
        }

        email = ParseUtils.parseString(user.getEmail());
        phoneNumber = ParseUtils.parseString(user.getPhoneNumber());
        userName = ParseUtils.parseString(user.getUserName());
        if(user.getPosition() != null) {
            positionId = ParseUtils.parseString(user.getPosition().getId());
        }
        active = ParseUtils.convertToYNChar(user.getActive());
        version = ParseUtils.convertLong(user.getVersion());
    }
}
