package org.mmc.web.forms.administration;

import org.mmc.web.forms.BaseValidatorForm;
import org.mmc.utils.ParseUtils;
import org.mmc.model.domain.ProbeType;
import org.mmc.model.filters.ProbeTypesFilter;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;

import javax.servlet.http.HttpServletRequest;

/**
 * Created on: 2007-9-20
 *
 * @author Stoyo Venkov
 */
public class ProbeTypeForm extends BaseValidatorForm {
    private String id;
    private String name;
    private String active;
    private String version;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getActive() {
        return active;
    }

    public void setActive(String active) {
        this.active = active;
    }

    public String getVersion() {
        return version;
    }

    public void setVersion(String version) {
        this.version = version;
    }

    public ProbeType createDomainObject() {
        ProbeType result = new ProbeType();
        result.setId(ParseUtils.parseLong(id));
        result.setName(name);
        result.setActive(ParseUtils.convertToBooleanNoNull(active));
        result.setVersion(ParseUtils.parseLong(version));
        return result;
    }

    public void initializeFilterObject(ProbeTypesFilter filter) {
        filter.setName(ParseUtils.parseString(name));
        filter.setActive(ParseUtils.convertToBoolean(active));
    }

    public void initializFormFromFilter(ProbeTypesFilter filter) {
        name = filter.getName();
        active = ParseUtils.convertToYNChar(filter.getActive());
    }

    public void initializFormFromDomainObject(ProbeType position) {
        id = ParseUtils.convertLong(position.getId());
        name = position.getName();
        active = ParseUtils.convertToYNChar(position.getActive());
        version = ParseUtils.convertLong(position.getVersion());
    }

    public ActionErrors validate(ActionMapping actionMapping, HttpServletRequest httpServletRequest) {
        ActionErrors errors = new ActionErrors();

        checkRequiredStrField(errors, name, "label.nameLong");

        return errors;
    }

}
