package org.mmc.web.forms.probes;

import org.mmc.web.forms.BaseValidatorForm;
import org.mmc.utils.StringUtils;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;

import javax.servlet.http.HttpServletRequest;

/**
 * Created on: 2007-10-13
 *
 * @author Stoyo Venkov
 */
public class RegisterMovementForm extends BaseValidatorForm {
    private String stepId;
    private String prevLocationId;
    private String tubeId;
    private String rackId;
    private String plateId;
    private String batchGroupId;
    private String coordinates;

    public String getStepId() {
        return stepId;
    }

    public void setStepId(String stepId) {
        this.stepId = stepId;
    }

    public String getPrevLocationId() {
        return prevLocationId;
    }

    public void setPrevLocationId(String prevLocationId) {
        this.prevLocationId = prevLocationId;
    }

    public String getTubeId() {
        return tubeId;
    }

    public void setTubeId(String tubeId) {
        this.tubeId = tubeId;
    }

    public String getRackId() {
        return rackId;
    }

    public void setRackId(String rackId) {
        this.rackId = rackId;
    }

    public String getPlateId() {
        return plateId;
    }

    public void setPlateId(String plateId) {
        this.plateId = plateId;
    }

    public String getBatchGroupId() {
        return batchGroupId;
    }

    public void setBatchGroupId(String batchGroupId) {
        this.batchGroupId = batchGroupId;
    }

    public String getCoordinates() {
        return coordinates;
    }

    public void setCoordinates(String coordinates) {
        this.coordinates = coordinates;
    }

    public ActionErrors validate(ActionMapping actionMapping, HttpServletRequest httpServletRequest) {
        ActionErrors errors = new ActionErrors();

        checkRequiredStrField(errors, stepId, "label.step");
        checkLongField(errors, stepId, "label.step");
        checkLongField(errors, tubeId, "label.tubeRegNum");
        checkLongField(errors, rackId, "label.rackRegNum");
        checkLongField(errors, plateId, "label.plateRegNum");
        checkLongField(errors, batchGroupId, "label.batchGroupRegNum");

        if(StringUtils.isEmpty(tubeId) && StringUtils.isEmpty(rackId) && StringUtils.isEmpty(plateId)) {
            addError(errors, "error.provideLocation");
        }

        if(StringUtils.isEmpty(coordinates) && (!StringUtils.isEmpty(rackId) || !StringUtils.isEmpty(plateId))) {
            addError(errors, "error.provideCoordinates");
        }

        return errors;
    }
}
