package org.mmc.web.forms.probes;

import org.mmc.web.forms.BaseValidatorForm;
import org.mmc.utils.StringUtils;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * Created on: 2007-10-9
 *
 * @author Stoyo Venkov
 */
public class RegisterProbeForm extends BaseValidatorForm {
    private String patientId;
    private String requestId;
    private String analysisTerm;
    private String probeTypeId;
    private String tubeId;

    private List probeTypesList;

    private List availableCriteriaList;
    private List criteriaList;
    private String[] availableCriteria;
    private String[] chosenCriteria;

    private List availableProjectsList;
    private List projectsList;
    private String[] availableProjects;
    private String[] chosenProjects;

    public String getPatientId() {
        return patientId;
    }

    public void setPatientId(String patientId) {
        this.patientId = patientId;
    }

    public String getRequestId() {
        return requestId;
    }

    public void setRequestId(String requestId) {
        this.requestId = requestId;
    }

    public String getAnalysisTerm() {
        return analysisTerm;
    }

    public void setAnalysisTerm(String analysisTerm) {
        this.analysisTerm = analysisTerm;
    }

    public String getProbeTypeId() {
        return probeTypeId;
    }

    public void setProbeTypeId(String probeTypeId) {
        this.probeTypeId = probeTypeId;
    }

    public String getTubeId() {
        return tubeId;
    }

    public void setTubeId(String tubeId) {
        this.tubeId = tubeId;
    }

    public List getProbeTypesList() {
        return probeTypesList;
    }

    public void setProbeTypesList(List probeTypesList) {
        this.probeTypesList = probeTypesList;
    }

    public List getAvailableCriteriaList() {
        return availableCriteriaList;
    }

    public void setAvailableCriteriaList(List availableCriteriaList) {
        this.availableCriteriaList = availableCriteriaList;
    }

    public List getCriteriaList() {
        return criteriaList;
    }

    public void setCriteriaList(List criteriaList) {
        this.criteriaList = criteriaList;
    }

    public String[] getAvailableCriteria() {
        return availableCriteria;
    }

    public void setAvailableCriteria(String[] availableCriteria) {
        this.availableCriteria = availableCriteria;
    }

    public String[] getChosenCriteria() {
        return chosenCriteria;
    }

    public void setChosenCriteria(String[] chosenCriteria) {
        this.chosenCriteria = chosenCriteria;
    }

    public List getAvailableProjectsList() {
        return availableProjectsList;
    }

    public void setAvailableProjectsList(List availableProjectsList) {
        this.availableProjectsList = availableProjectsList;
    }

    public List getProjectsList() {
        return projectsList;
    }

    public void setProjectsList(List projectsList) {
        this.projectsList = projectsList;
    }

    public String[] getAvailableProjects() {
        return availableProjects;
    }

    public void setAvailableProjects(String[] availableProjects) {
        this.availableProjects = availableProjects;
    }

    public String[] getChosenProjects() {
        return chosenProjects;
    }

    public void setChosenProjects(String[] chosenProjects) {
        this.chosenProjects = chosenProjects;
    }

    public ActionErrors validate(ActionMapping actionMapping, HttpServletRequest httpServletRequest) {
        ActionErrors errors = new ActionErrors();

        checkRequiredStrField(errors, patientId, "error.choosePatient");
        checkRequiredStrField(errors, requestId, "error.chooseRequest");
        checkRequiredStrField(errors, analysisTerm, "label.daysToComplete");
        checkRequiredStrField(errors, probeTypeId, "label.probeType");
        checkRequiredStrField(errors, tubeId, "label.tube");
        checkLongField(errors, analysisTerm, "label.daysToComplete");
        checkLongField(errors, tubeId, "label.tube");
        checkLongField(errors, probeTypeId, "label.probeType");
        checkLongField(errors, patientId, "error.choosePatient");
        checkLongField(errors, requestId, "error.chooseRequest");

        if (chosenCriteria == null || chosenCriteria.length == 0) {
            addError(errors, "error.chooseCriteria");
        }

        if (chosenProjects == null || chosenProjects.length == 0) {
            addError(errors, "error.chooseProject");
        }

        return errors;
    }
}
