package org.mmc.web.forms.probes;

import org.mmc.web.forms.BaseValidatorForm;
import org.mmc.web.forms.search.SearchValidatorForm;
import org.mmc.utils.ParseUtils;
import org.mmc.model.filters.ProbesFilter;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * Created on: 2007-10-12
 *
 * @author Stoyo Venkov
 */
public class SearchProbeForm extends BaseValidatorForm implements SearchValidatorForm {
    private String id;
    private String regFromDate;
    private String regToDate;
    private String creatorId;
    private String senderId;
    private String projectId;
    private String patientId;
    private String requestId;
    private String tubeId;
    private String rackId;
    private String plateId;
    private String batchGroupId;
    private String term;

    private String patientNameInfo;

    private List usersList;
    private List projectsList;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getRegFromDate() {
        return regFromDate;
    }

    public void setRegFromDate(String regFromDate) {
        this.regFromDate = regFromDate;
    }

    public String getRegToDate() {
        return regToDate;
    }

    public void setRegToDate(String regToDate) {
        this.regToDate = regToDate;
    }

    public String getCreatorId() {
        return creatorId;
    }

    public void setCreatorId(String creatorId) {
        this.creatorId = creatorId;
    }

    public String getSenderId() {
        return senderId;
    }

    public void setSenderId(String senderId) {
        this.senderId = senderId;
    }

    public String getProjectId() {
        return projectId;
    }

    public void setProjectId(String projectId) {
        this.projectId = projectId;
    }

    public String getPatientId() {
        return patientId;
    }

    public void setPatientId(String patientId) {
        this.patientId = patientId;
    }

    public String getRequestId() {
        return requestId;
    }

    public void setRequestId(String requestId) {
        this.requestId = requestId;
    }

    public String getTubeId() {
        return tubeId;
    }

    public void setTubeId(String tubeId) {
        this.tubeId = tubeId;
    }

    public String getRackId() {
        return rackId;
    }

    public void setRackId(String rackId) {
        this.rackId = rackId;
    }

    public String getPlateId() {
        return plateId;
    }

    public void setPlateId(String plateId) {
        this.plateId = plateId;
    }

    public String getBatchGroupId() {
        return batchGroupId;
    }

    public void setBatchGroupId(String batchGroupId) {
        this.batchGroupId = batchGroupId;
    }

    public String getPatientNameInfo() {
        return patientNameInfo;
    }

    public void setPatientNameInfo(String patientNameInfo) {
        this.patientNameInfo = patientNameInfo;
    }

    public List getUsersList() {
        return usersList;
    }

    public void setUsersList(List usersList) {
        this.usersList = usersList;
    }

    public List getProjectsList() {
        return projectsList;
    }

    public void setProjectsList(List projectsList) {
        this.projectsList = projectsList;
    }

    public String getTerm() {
        return term;
    }

    public void setTerm(String term) {
        this.term = term;
    }

    public void initializeFilterObject(ProbesFilter filter) {
        filter.setId(ParseUtils.parseLong(id));
        filter.setCreatorId(ParseUtils.parseLong(creatorId));
        filter.setSenderId(ParseUtils.parseLong(senderId));
        filter.setPatientId(ParseUtils.parseLong(patientId));
        filter.setRequestId(ParseUtils.parseLong(requestId));
        filter.setTubeId(ParseUtils.parseLong(tubeId));
        filter.setRackId(ParseUtils.parseLong(rackId));
        filter.setPlateId(ParseUtils.parseLong(plateId));
        filter.setBatchGroupId(ParseUtils.parseLong(batchGroupId));
        filter.setRegFromDate(ParseUtils.parseDate(regFromDate));
        filter.setRegToDate(ParseUtils.parseDate(regToDate));
        filter.setProjectId(ParseUtils.parseLong(projectId));
        filter.setTerm(ParseUtils.parseString(term));
    }

    public void initializFormFromFilter(ProbesFilter filter) {
        id = ParseUtils.parseString(filter.getId());
        creatorId = ParseUtils.parseString(filter.getCreatorId());;
        senderId = ParseUtils.parseString(filter.getSenderId());
        patientId = ParseUtils.parseString(filter.getPatientId());
        requestId = ParseUtils.parseString(filter.getRequestId());
        tubeId = ParseUtils.parseString(filter.getTubeId());
        rackId = ParseUtils.parseString(filter.getRackId());
        plateId = ParseUtils.parseString(filter.getPlateId());
        batchGroupId = ParseUtils.parseString(filter.getBatchGroupId());
        regFromDate = ParseUtils.convertDate(filter.getRegFromDate());
        regToDate = ParseUtils.convertDate(filter.getRegToDate());
        projectId = ParseUtils.parseString(filter.getProjectId());
        term = ParseUtils.parseString(filter.getTerm());
    }

    public ActionErrors validate(ActionMapping actionMapping, HttpServletRequest httpServletRequest) {
        ActionErrors errors = new ActionErrors();

        checkDateField(errors, regFromDate, "label.registeredAfter");
        checkDateField(errors, regToDate, "label.registeredBefore");
        checkLongField(errors, tubeId, "label.birhtDay");
        checkLongField(errors, rackId, "label.birhtMonth");
        checkLongField(errors, plateId, "label.birhtYear");
        checkLongField(errors, batchGroupId, "label.birhtYear");

        return errors;
    }
}
