package org.mmc.web.forms.requests;

import org.mmc.web.forms.BaseValidatorForm;
import org.mmc.web.forms.search.SearchValidatorForm;
import org.mmc.model.filters.PatientsFilter;
import org.mmc.utils.ParseUtils;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * Created on: 2007-10-7
 *
 * @author Stoyo Venkov
 */
public class SearchPatientForm extends BaseValidatorForm implements SearchValidatorForm {
    private String firstName;
    private String familyName;
    private String uniqueNumber;
    private String initials;
    private String sexId;
    private String ethnicGroupId;
    private String birthDay;
    private String birthMonth;
    private String birthYear;
    private String regFromDate;
    private String regToDate;
    private String projectId;

    private List sexesList;
    private List projectsList;
    private List ethnicGroupsList;

    public String getFirstName() {
        return firstName;
    }

    public void setFirstName(String firstName) {
        this.firstName = firstName;
    }

    public String getFamilyName() {
        return familyName;
    }

    public void setFamilyName(String familyName) {
        this.familyName = familyName;
    }

    public String getUniqueNumber() {
        return uniqueNumber;
    }

    public void setUniqueNumber(String uniqueNumber) {
        this.uniqueNumber = uniqueNumber;
    }

    public String getInitials() {
        return initials;
    }

    public void setInitials(String initials) {
        this.initials = initials;
    }

    public String getSexId() {
        return sexId;
    }

    public void setSexId(String sexId) {
        this.sexId = sexId;
    }

    public String getEthnicGroupId() {
        return ethnicGroupId;
    }

    public void setEthnicGroupId(String ethnicGroupId) {
        this.ethnicGroupId = ethnicGroupId;
    }

    public String getBirthDay() {
        return birthDay;
    }

    public void setBirthDay(String birthDay) {
        this.birthDay = birthDay;
    }

    public String getBirthMonth() {
        return birthMonth;
    }

    public void setBirthMonth(String birthMonth) {
        this.birthMonth = birthMonth;
    }

    public String getBirthYear() {
        return birthYear;
    }

    public void setBirthYear(String birthYear) {
        this.birthYear = birthYear;
    }

    public String getRegFromDate() {
        return regFromDate;
    }

    public void setRegFromDate(String regFromDate) {
        this.regFromDate = regFromDate;
    }

    public String getRegToDate() {
        return regToDate;
    }

    public void setRegToDate(String regToDate) {
        this.regToDate = regToDate;
    }

    public String getProjectId() {
        return projectId;
    }

    public void setProjectId(String projectId) {
        this.projectId = projectId;
    }

    public List getSexesList() {
        return sexesList;
    }

    public void setSexesList(List sexesList) {
        this.sexesList = sexesList;
    }

    public List getProjectsList() {
        return projectsList;
    }

    public void setProjectsList(List projectsList) {
        this.projectsList = projectsList;
    }

    public List getEthnicGroupsList() {
        return ethnicGroupsList;
    }

    public void setEthnicGroupsList(List ethnicGroupsList) {
        this.ethnicGroupsList = ethnicGroupsList;
    }

    public void initializeFilterObject(PatientsFilter filter) {
        filter.setFirstName(ParseUtils.parseString(firstName));
        filter.setFamilyName(ParseUtils.parseString(familyName));
        filter.setInitials(ParseUtils.parseString(initials));
        filter.setUniqueNumber(ParseUtils.parseString(uniqueNumber));
        filter.setSexId(ParseUtils.parseLong(sexId));
        filter.setEthnicGroupId(ParseUtils.parseLong(ethnicGroupId));
        filter.setBirthDay(ParseUtils.parseInteger(birthDay));
        filter.setBirthMonth(ParseUtils.parseInteger(birthMonth));
        filter.setBirthYear(ParseUtils.parseInteger(birthYear));
        filter.setRegFromDate(ParseUtils.parseDate(regFromDate));
        filter.setRegToDate(ParseUtils.parseDate(regToDate));
        filter.setProjectId(ParseUtils.parseLong(projectId));
    }

    public void initializFormFromFilter(PatientsFilter filter) {
        firstName = filter.getFirstName();
        familyName = filter.getFamilyName();
        initials = filter.getInitials();
        uniqueNumber = filter.getUniqueNumber();
        sexId = ParseUtils.parseString(filter.getSexId());
        ethnicGroupId = ParseUtils.parseString(filter.getEthnicGroupId());
        birthDay = ParseUtils.parseString(filter.getBirthDay());
        birthMonth = ParseUtils.parseString(filter.getBirthMonth());
        birthYear = ParseUtils.parseString(filter.getBirthYear());
        regFromDate = ParseUtils.convertDate(filter.getRegFromDate());
        regToDate = ParseUtils.convertDate(filter.getRegToDate());
        projectId = ParseUtils.parseString(filter.getProjectId());
    }

    public ActionErrors validate(ActionMapping actionMapping, HttpServletRequest httpServletRequest) {
        ActionErrors errors = new ActionErrors();

        checkDateField(errors, regFromDate, "label.registeredAfter");
        checkDateField(errors, regToDate, "label.registeredBefore");
        checkLongField(errors, birthDay, "label.birhtDay");
        checkLongField(errors, birthMonth, "label.birhtMonth");
        checkLongField(errors, birthYear, "label.birhtYear");

        return errors;
    }
}
