package org.mmc.web.forms.requests;

import org.mmc.web.forms.BaseValidatorForm;
import org.mmc.web.forms.search.SearchValidatorForm;
import org.mmc.utils.ParseUtils;
import org.mmc.model.filters.RequestsFilter;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * Created on: 2007-10-8
 *
 * @author Stoyo Venkov
 */
public class SearchRequestForm extends BaseValidatorForm implements SearchValidatorForm {
    private String id;
    private String regFromDate;
    private String regToDate;
    private String patientId;
    private String userId;

    private String patientNameInfo;

    private List usersList;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getRegFromDate() {
        return regFromDate;
    }

    public void setRegFromDate(String regFromDate) {
        this.regFromDate = regFromDate;
    }

    public String getRegToDate() {
        return regToDate;
    }

    public void setRegToDate(String regToDate) {
        this.regToDate = regToDate;
    }

    public String getPatientId() {
        return patientId;
    }

    public void setPatientId(String patientId) {
        this.patientId = patientId;
    }

    public String getUserId() {
        return userId;
    }

    public void setUserId(String userId) {
        this.userId = userId;
    }

    public String getPatientNameInfo() {
        return patientNameInfo;
    }

    public void setPatientNameInfo(String patientNameInfo) {
        this.patientNameInfo = patientNameInfo;
    }

    public List getUsersList() {
        return usersList;
    }

    public void setUsersList(List usersList) {
        this.usersList = usersList;
    }

    public void initializeFilterObject(RequestsFilter filter) {
        filter.setId(ParseUtils.parseLong(id));
        filter.setRegFromDate(ParseUtils.parseDate(regFromDate));
        filter.setRegToDate(ParseUtils.parseDate(regToDate));
        filter.setPatientId(ParseUtils.parseLong(patientId));
        filter.setUserId(ParseUtils.parseLong(userId));
    }

    public void initializFormFromFilter(RequestsFilter filter) {
        id = ParseUtils.parseString(filter.getId());
        regFromDate = ParseUtils.convertDate(filter.getRegFromDate());
        regToDate = ParseUtils.convertDate(filter.getRegToDate());
        patientId = ParseUtils.parseString(filter.getPatientId());
        userId = ParseUtils.parseString(filter.getUserId());
    }

    public ActionErrors validate(ActionMapping actionMapping, HttpServletRequest httpServletRequest) {
        ActionErrors errors = new ActionErrors();

        checkDateField(errors, regFromDate, "label.registeredAfterN");
        checkDateField(errors, regToDate, "label.registeredBeforeN");

        return errors;
    }
}
